;;; chinese-wbim-wb-gb2312.el --- Enable Wubi(五笔) Input Method in Emacs.

;; Copyright (C) 2015-2016, Guanghui Qu

;; Author: Guanghui Qu<guanghui8827@gmail.com>
;; URL: https://github.com/andyque/chinese-wbim
;; Version: 0.1
;; Keywords: Wubi Input Method.
;;
;; This file is not part of GNU Emacs.

;;; Credits:

;; - Original Author: wenbinye@163.com

;;; License:

;; This file is part of chinese-wbim
;;
;; chinese-wbim is free software: you can redistribute it and/or
;; modify it under the terms of the GNU General Public License as published
;; by the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; chinese-wbim is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;
;;; Commentary:
;;
;;; Code:
(chinese-wbim-make-char-table '(
("aaaa" "工")
("aad" "式")
("aadk" "匿")
("aadn" "慝" "葚")
("aadw" "萁")
("aafd" "甙")
("aaff" "苷")
("aaht" "芽")
("aak" "戒")
("aanf" "苣")
("aatq" "荛")
("abef" "荫")
("abf" "茸")
("abh" "邛")
("abib" "菡")
("abio" "蒸")
("abiu" "荪")
("abj" "节")
("abmj" "茁")
("abnb" "芤")
("abry" "菰")
("abut" "萨")
("acaf" "茎")
("acb" "芭")
("acbm" "蓣")
("acbt" "茅")
("ackf" "苔")
("ackg" "※")
("adaj" "莽")
("adaw" "蕻")
("adbb" "苊")
("adcu" "茇")
("ade" "戎")
("adef" "葫")
("adf" "苦")
("adff" "蓐")
("adfi" "萘")
("adgt" "葳")
("adhb" "荐")
("adhd" "葜")
("adhf" "茬")
("adij" "藉")
("adiy" "藕")
("adjd" "菲" "匪")
("adkf" "若")
("adkn" "惹")
("adlb" "苈")
("admt" "蒇")
("admy" "项")
("adnt" "藏" "茂")
("aduw" "蕨")
("adwa" "戡")
("adwe" "期")
("adwf" "斟" "基")
("adwi" "綦")
("adwl" "勘")
("adwn" "甚")
("adwr" "斯")
("adwt" "蓁")
("adwu" "其")
("adww" "欺")
("adxb" "茏")
("aeb" "艿")
("aebc" "菔")
("aebf" "莩")
("aeej" "蒯")
("aeeq" "藐")
("aegf" "苴")
("aesu" "菜")
("aetg" "蕤")
("aety" "散")
("aeui" "藤")
("aevf" "荽")
("aeyu" "芨")
("afab" "鞯")
("afae" "鞴")
("afbh" "邯")
("afcn" "靶")
("afcs" "鞣")
("afcu" "芸" "芰")
("afd" "甘")
("afdj" "薷")
("afdp" "鞑")
("aff" "芏")
("afff" "鞋" "鞲" "葑")
("afga" "◇")
("afie" "鞘")
("afii" "蒜")
("afj" "革")
("afjg" "靼")
("afkf" "薹")
("aflf" "蕾")
("afln" "勒")
("afmd" "鞅")
("afmi" "贰")
("afnh" "苇")
("afpb" "荸")
("afpv" "鞍")
("afqb" "芫" "芜")
("afqo" "鞠")
("afqq" "鞔")
("afqw" "莰")
("afqy" "鞫")
("afrh" "靳")
("afsu" "某")
("aftj" "鞒" "蓍" "著")
("afuk" "蔷")
("afwq" "鞭")
("afwt" "菱")
("afwu" "芙")
("afwx" "靴")
("afwy" "藿")
("agaj" "荆")
("agd" "匡")
("agef" "菁")
("agey" "莆")
("agfj" "芋")
("aghg" "廿")
("aghh" "艹")
("agho" "蔫")
("agig" "苤")
("agjn" "蕙")
("agkw" "蔌")
("agmh" "芾")
("agmm" "颟")
("agn" "匚" "七")
("agnn" "巧")
("agnt" "戈")
("agny" "弋")
("agou" "莱")
("agqa" "葬")
("agqg" "薤")
("agsu" "茉")
("agth" "廾")
("aguh" "苹")
("aguw" "荚")
("agvv" "萋")
("agxw" "荑")
("ahap" "蘧")
("ahf" "芷" "苜")
("ahic" "菽")
("ahkf" "苫")
("ahkm" "颐" "赜")
("ahko" "熙")
("ahnh" "卧" "臣")
("ahtb" "邪")
("ahte" "牙")
("ahtg" "鸦")
("ahtp" "迓")
("ahty" "雅")
("ahxb" "茈")
("aiaf" "茳")
("aias" "蕖")
("aibb" "范")
("aieg" "菹")
("aigf" "薄")
("aigh" "萍")
("aigy" "蒲")
("aihc" "菠")
("aii" "东")
("aiit" "莎")
("aiks" "藻")
("ainr" "荡")
("aiqg" "鸫")
("aire" "蒎")
("aisk" "菏")
("aitk" "落")
("aitl" "藩")
("aiu" "汞")
("aiye" "蒗")
("aiyn" "茫")
("ajbc" "蕞")
("ajdc" "蓦")
("ajdf" "墓")
("ajdh" "幕")
("ajdj" "暮")
("ajdl" "募")
("ajdn" "慕")
("ajdr" "摹")
("ajdu" "莫")
("ajef" "萌")
("ajf" "昔")
("ajfu" "莳")
("ajh" "划")
("ajj" "草")
("ajjf" "菖")
("ajlc" "蔓")
("ajqg" "鹊")
("ajqn" "葛")
("ajtl" "蓝")
("aju" "茧")
("ajvb" "郾")
("akbf" "葺")
("akbt" "蕺")
("akd" "叵")
("akgb" "鄞")
("akgd" "或")
("akgf" "堇")
("akgl" "勤")
("akgn" "惑")
("akgq" "觐")
("akhm" "匮" "蒉")
("akkf" "莒")
("akkg" "鹳")
("akkm" "颧")
("akkn" "萼")
("akmw" "莴")
("aldn" "蒽")
("aldt" "蔑")
("aldu" "茵")
("alf" "苗")
("alfj" "薯")
("alk" "匣")
("alkf" "茴" "茄")
("alll" "荔")
("aln" "功")
("alnu" "葸")
("alph" "瞢")
("alpn" "甍")
("alpu" "莲")
("alpx" "薨")
("alqg" "鹋")
("alqu" "萝")
("altu" "菌")
("alvv" "匦")
("alwu" "苏")
("amcu" "芟")
("amdu" "英")
("amff" "苒")
("amgk" "茼")
("amhk" "匝" "萜")
("amkf" "苘")
("amqb" "苋")
("amqu" "￡")
("amu" "贡")
("amwu" "芮" "黄")
("amyh" "跫")
("amyj" "蛩")
("amyn" "恐")
("amyq" "銎")
("amyy" "巩")
("anab" "苠")
("anb" "艺" "芑")
("and" "巨")
("anff" "蔚")
("anhc" "葭")
("anhq" "蔬")
("ani" "忒")
("anku" "薜")
("anmu" "贳")
("annn" "蕊")
("anu" "芯")
("anud" "荬")
("anv" "世")
("anwe" "蓼")
("anyu" "荩")
("anyw" "苡")
("aovf" "蒌")
("aovt" "薮")
("apdf" "菪")
("apff" "茔")
("apfl" "蔻")
("apfq" "莞")
("apge" "蒙")
("apgf" "苎")
("apgg" "萱")
("apgy" "莹")
("apiu" "荥")
("apju" "萤")
("apkk" "营")
("aplb" "劳")
("aplj" "荤")
("apnf" "茕")
("apnn" "菅")
("apou" "荧")
("apqb" "菀")
("apqf" "蓥")
("apqg" "莺")
("aprh" "荦")
("apsu" "荣")
("apu" "芝")
("apwj" "蓿")
("apwk" "蓉")
("apxi" "萦")
("aqab" "芪")
("aqbb" "苑")
("aqgb" "茚")
("aqgd" "藓")
("aqgj" "蓟")
("aqgn" "瓯")
("aqgy" "葡")
("aqjf" "荀")
("aqkf" "茗" "苟")
("aqkr" "擎")
("aqks" "檠")
("aqkt" "敬")
("aqky" "警" "菟")
("aqmc" "殴")
("aqnb" "苞")
("aqou" "菊")
("aqqg" "鸥")
("aqqw" "欧")
("aqrm" "萄")
("aqrn" "葱")
("aqrq" "蔸")
("aqrr" "芴")
("aqtb" "茆")
("aqtd" "获")
("aqtn" "莸")
("aqto" "荻")
("aqu" "艾")
("aqv" "匹")
("aqvf" "萏")
("aqwu" "芡")
("aqyg" "鸢" "茑")
("aqyu" "芍")
("arcb" "葩")
("ardc" "菝")
("ariu" "茱")
("arj" "芹")
("ark" "匠")
("artf" "萆")
("asf" "茜")
("asgf" "苯")
("asgo" "蘸")
("ashf" "葙")
("asjj" "蕈")
("askf" "苛")
("asrj" "菥")
("aswc" "菘")
("atay" "苌")
("atdi" "医")
("atdj" "荞")
("atdn" "翳")
("atdp" "蓬")
("ateb" "莠")
("atfh" "荇")
("atfj" "芊")
("atfp" "莛")
("atgf" "董")
("atgn" "翘")
("atgo" "薰")
("atgq" "尧")
("athh" "蓰")
("atjj" "莉")
("atlx" "蓖")
("atmt" "薇")
("atol" "蕃")
("atqh" "蘅")
("atqi" "藜")
("atrt" "莪")
("atvf" "萎")
("atxi" "蘩")
("atxu" "莓")
("aty" "攻")
("aube" "蒴")
("auj" "莘")
("aujn" "薏")
("aujr" "蕲")
("aukf" "菩")
("auko" "燕")
("aumt" "蔽")
("auph" "蒂")
("aupy" "蒡")
("auqf" "蒋")
("auqu" "茭")
("auqw" "茨")
("ausr" "薪")
("autd" "蒺")
("auvo" "蒹")
("auwy" "蔺")
("avb" "艽")
("avdf" "菇" "薅")
("aveu" "茛")
("avfu" "荨")
("avij" "萧")
("avkf" "苕" "茹")
("avn" "切")
("avwu" "萸")
("avyu" "芄")
("awbb" "苍")
("awcn" "蓊")
("awdu" "茯")
("awfc" "荟")
("awff" "茌")
("awfi" "蔡")
("awfu" "苻")
("awgd" "葵")
("awgf" "荃")
("awgi" "莶")
("awgt" "蔹")
("awht" "莜")
("awjj" "芥")
("awks" "葆")
("awnb" "巷" "孽")
("awns" "蘖")
("awnu" "薛" "恭")
("awsk" "荷")
("awsu" "茶")
("awtf" "荏")
("awtu" "荼")
("awu" "共")
("awuf" "莅")
("awuk" "蓓")
("awvb" "芬")
("awwi" "巫")
("awwq" "觋")
("awwu" "苁")
("awxb" "花")
("awyc" "苓")
("awyf" "萑")
("awyj" "劐")
("awyn" "芩")
("awyo" "蕉")
("axaf" "荭")
("axb" "芎")
("axfu" "荮")
("axgn" "莼")
("axjl" "蕴")
("axqy" "药")
("axtr" "芗")
("axxb" "芘")
("axxf" "荜")
("axxr" "蒈")
("ayao" "蔗")
("ayb" "芳")
("aybc" "蓠")
("aycq" "茺")
("ayhu" "苄")
("ayjj" "荠")
("ayjn" "蔼")
("ayke" "蓑")
("aymk" "蒿")
("ayms" "藁")
("ayna" "匾")
("aynb" "芒")
("aynq" "荒")
("aynr" "芦")
("ayps" "葶")
("aysd" "蘑" "蘼")
("aytd" "蔟")
("ayve" "莨")
("aywf" "萃")
("aywu" "菸")
("ayxl" "蓄")
("ayxy" "蕹")
("baiy" "陈")
("bbbb" "子")
("bbcy" "陬")
("bbh" "耶")
("bcag" "陉")
("bccm" "颞")
("bccu" "聂")
("bctb" "鄹")
("bcti" "聚")
("bcvf" "娶")
("bcy" "取")
("bdae" "隋")
("bdan" "隳")
("bdef" "堕")
("bdep" "随")
("bdii" "承")
("bdjg" "陌")
("bdxn" "陇")
("beg" "阴")
("begg" "阻")
("bfdj" "孺")
("bfhy" "陡")
("bfiy" "际")
("bfjh" "阱")
("bfmh" "陆")
("bfqn" "阮")
("bfwt" "陵")
("bgd" "卫")
("bghg" "耳")
("bgkh" "隔")
("bgmn" "陋")
("bgqn" "阢")
("bguw" "陕")
("bhcy" "陂")
("bhg" "耻")
("bhgj" "蚩")
("bhic" "骘")
("bhit" "陟")
("bhk" "屮")
("bhkg" "阽")
("bibk" "函")
("bigb" "卺")
("bigf" "丞")
("biji" "隙")
("bipi" "逊")
("biy" "孙")
("bjfg" "陧")
("bjg" "阳")
("bjmy" "隅")
("bjxo" "隰")
("bkcg" "亟")
("bkhm" "聩")
("bkmy" "陨")
("bkwy" "职")
("blf" "孟")
("blge" "隈")
("blh" "阵")
("blln" "勐")
("bmfg" "聃")
("bmfi" "祟")
("bmgn" "聘")
("bmk" "出")
("bmou" "粜")
("bnh" "卩" "了" "阝" "凵")
("bnhg" "孑")
("bnhn" "也")
("bnn" "孔")
("boy" "耿")
("bpfq" "院")
("bpk" "辽")
("bpqn" "耽")
("bpsh" "聍")
("bpxn" "陀")
("bqnn" "孢")
("bqrm" "陶")
("bqtb" "聊")
("bqvg" "陷")
("bqvn" "隐")
("brcy" "阪" "孤")
("brgg" "隍")
("brqc" "隗")
("brtf" "陴")
("bsh" "耵")
("bskg" "阿")
("btah" "降")
("btdg" "聒")
("btfh" "阡")
("btgf" "陲")
("btgg" "隆")
("bthf" "阼")
("bty" "孜")
("budy" "联")
("buep" "隧")
("bujh" "障")
("bukg" "陪")
("bukn" "聪")
("buwl" "隘")
("bvey" "限")
("bwff" "坠")
("bwfy" "附")
("bwgi" "险")
("bwjh" "阶")
("bwty" "除")
("bwy" "队")
("bwyc" "聆")
("bxxf" "陛")
("byi" "孓")
("byn" "防")
("bynw" "孩" "陔")
("cadm" "颈")
("cadw" "骐")
("caj" "弁")
("cajh" "刭")
("caln" "劲")
("capd" "迳")
("caqy" "驱")
("cat" "戏")
("catq" "骁")
("cayq" "巯")
("cbci" "骤")
("cbdm" "预")
("cbh" "邓")
("cbj" "予")
("cbn" "驰")
("cbqe" "豫")
("cbtc" "骛")
("cbtg" "鹬" "鹜")
("cbth" "瞀")
("cbtj" "蟊" "蝥")
("cbtn" "矜")
("cbtq" "鍪")
("cbtr" "矛")
("cbts" "柔")
("cbtv" "婺")
("cccc" "又")
("cccf" "垒")
("cccg" "叠")
("cccm" "颡")
("cccs" "桑")
("ccde" "骖")
("ccfh" "驿")
("cckg" "骀")
("ccwt" "骏")
("ccy" "双" "驭")
("ccyj" "骚")
("cddf" "叁")
("cden" "毵")
("cder" "参")
("cdlf" "畚")
("cdsk" "骑")
("cdy" "驮")
("cegg" "驵")
("cej" "甬")
("celb" "勇")
("cenu" "恿")
("cepk" "通")
("cexo" "熊")
("cexx" "能")
("cff" "圣")
("cfnu" "怼")
("cfqc" "√")
("cfy" "对")
("cgmy" "骊")
("cjsy" "骒")
("cjxg" "‖")
("ckbh" "邰")
("ckf" "台")
("ckh" "驯")
("cknu" "怠")
("ckou" "炱")
("ckpd" "迨")
("ckqy" "驶")
("clg" "驷")
("cln" "劝")
("clxi" "骡")
("cmgn" "骋")
("cmqn" "观")
("cnbb" "骣")
("cnfg" "士")
("cnhn" "巴")
("cnng" "马")
("cny" "厶")
("cpxn" "驼")
("cqb" "允")
("cqkg" "驹")
("cqqy" "驳")
("cqvg" "驺")
("cqwy" "欢")
("cqyg" "鸡")
("cqyl" "骝")
("crhj" "牟")
("crkg" "″")
("csfi" "骠")
("cskg" "”")
("ctdj" "骄")
("ctdu" "矣")
("ctkg" "骆")
("ctln" "骢")
("cuah" "骈")
("cuxw" "骥")
("cvey" "艰")
("cwfy" "驸")
("cwgi" "验")
("cwtc" "皴")
("cwtp" "逡")
("cwxf" "骅")
("cwyg" "骓" "难")
("cxkg" "“" "∶")
("cygg" "驻")
("cyi" "叉")
("cyju" "蚤")
("cyke" "骧")
("cyna" "骗")
("cynn" "骟")
("cynt" "驴")
("cynw" "骇")
("dadr" "厮")
("daf" "左")
("daht" "砑")
("daif" "礴")
("dajd" "厝")
("damh" "砸")
("damw" "磺")
("dans" "碟")
("dape" "礞")
("daqu" "奁")
("daqy" "砹")
("datq" "硗")
("davn" "砌")
("dawi" "礤")
("dayn" "硭")
("dbdm" "顾")
("dbf" "耷")
("dbmh" "础")
("dbv" "厄")
("dccs" "磉")
("dcde" "碜")
("dcg" "码")
("dcu" "友")
("dcwy" "雄")
("dddd" "大")
("dddf" "磊")
("dddl" "靥")
("dddn" "砺")
("dddq" "飙")
("ddgf" "＞")
("ddgt" "碱")
("ddht" "厦")
("ddi" "厌")
("ddlk" "厣")
("ddmy" "硕")
("ddnl" "励")
("ddnv" "厉")
("ddrc" "魇")
("ddu" "套")
("ddwe" "餍")
("debh" "郁")
("deeg" "硼")
("def" "有")
("defk" "髻")
("deg" "胡")
("degq" "髡")
("dehx" "髭")
("dele" "鬟")
("demf" "髯")
("depi" "鬃")
("depw" "鬓")
("deqg" "鹕")
("det" "髟")
("detn" "髦")
("deto" "鬏")
("deub" "鬈")
("devk" "髫")
("devn" "鬣")
("dews" "髹")
("dfaj" "奔")
("dfcl" "磕")
("dfcy" "砝")
("dfef" "辱")
("dfei" "辰")
("dfej" "蜃")
("dfek" "唇")
("dfff" "奎")
("dffg" "硅")
("dfh" "矸")
("dfiu" "奈")
("dfnb" "夸")
("dfnj" "刳")
("dfnn" "匏")
("dfny" "瓠" "砖")
("dftj" "奢")
("dfu" "夺")
("dfyi" "压")
("dgah" "研")
("dgaj" "硎")
("dgbn" "砘")
("dggg" "三")
("dghg" "古")
("dgjq" "硬")
("dgkf" "厨")
("dgkn" "感")
("dgkt" "咸")
("dglg" "礓")
("dgmy" "碛")
("dgnt" "戌")
("dgt" "厂")
("dgtg" "石" "≥")
("dgty" "犬")
("dguh" "砰")
("dguw" "硖")
("dgvt" "威")
("dgxu" "碡")
("dhar" "戛")
("dhbd" "存")
("dhcy" "破")
("dhdb" "酆")
("dhdf" "砉")
("dhdn" "慧")
("dhdv" "彗")
("dhfd" "在")
("dhih" "蹙")
("dhit" "戚")
("dhk" "丰")
("dhkg" "砧")
("dhqc" "艳")
("dhtu" "夏")
("dhvd" "契")
("dhvn" "恝")
("dhvr" "挈")
("dial" "耢")
("dias" "磲")
("dibg" "耔")
("dicn" "耙")
("didf" "耨")
("dieg" "硝")
("difc" "耘")
("diff" "耩")
("difj" "耕")
("dii" "耒")
("diik" "耥")
("diit" "耖")
("dijy" "耦")
("dinn" "耜")
("diov" "耧")
("ditn" "耗")
("ditt" "砂")
("diu" "泵")
("diuy" "耪")
("diwk" "耠")
("diyd" "耱")
("djbd" "厚")
("djdd" "非")
("djde" "裴")
("djdg" "韭")
("djdj" "蜚")
("djdl" "辈")
("djdn" "悲" "翡")
("djdy" "斐")
("djfd" "厘")
("djgf" "碍")
("djhh" "砷")
("djnb" "奄")
("djng" "鹌")
("djqn" "碣")
("dkf" "右")
("dkj" "夼")
("dlb" "夯")
("dlf" "奋")
("dlh" "砗")
("dlk" "厍")
("dlv" "历")
("dmaw" "碘")
("dmdo" "碳")
("dmfk" "碉")
("dmgk" "硐")
("dmhj" "布")
("dmjd" "面")
("dmjf" "耐")
("dmjg" "鸸")
("dmjj" "而")
("dmjk" "厕")
("dmjn" "恧")
("dmjv" "耍")
("dmn" "矶")
("dmqn" "砚")
("dmqy" "砜")
("dmu" "页")
("dmyy" "矾")
("dnae" "碾")
("dndt" "臧")
("dnhc" "嘏")
("dnjl" "尴")
("dnju" "虿")
("dnkh" "趸")
("dnln" "劢")
("dnnl" "盛")
("dnnt" "成")
("dnpv" "迈")
("dnqy" "尥")
("dnrt" "砀")
("dntk" "♂")
("dnv" "尢" "万" "尤")
("dnwj" "尬")
("dnyt" "戊")
("dolf" "盔")
("doqh" "磷")
("dou" "灰")
("dpgg" "碹")
("dpgh" "碇")
("dpi" "达")
("dpqb" "碗")
("dpqe" "Θ" "Ρ" "Ξ" "Δ" "Ι" "Ζ" "Ε" "Ψ" "Ο" "Τ" "Ω" "Η" "Β" "Γ" "Μ" "Υ" "Ν" "Φ" "Κ" "Σ" "Α" "Χ" "Λ" "Π")
("dprh" "牵")
("dpwy" "Д" "У" "К" "Ы" "Ё" "Е" "Т" "Ж" "Н" "Ш" "Я" "В" "Г" "Ю" "Л" "Ь" "С" "Й" "Э" "Щ" "Р" "Ц" "А" "П" "Ъ" "З" "М" "Х" "И" "О" "Ч" "Ф" "Б")
("dpxn" "砣")
("dqas" "磔")
("dqay" "砥")
("dqb" "克")
("dqdq" "兢")
("dqeh" "确")
("dqga" "△")
("dqiy" "砾")
("dqqq" "爽")
("dqwy" "砍")
("dqy" "矽")
("dqyg" "鸪")
("drh" "斫")
("drii" "原")
("drin" "愿")
("drkg" "｝" "｛")
("drtf" "碑")
("dsg" "硒")
("dshd" "厢")
("dsjg" "碴")
("dsk" "厅")
("dskf" "奇")
("dskj" "剞")
("dskw" "欹")
("dtbh" "邦" "帮")
("dtfo" "焘")
("dtfu" "寿")
("dthf" "砟")
("dtkg" "硌")
("dtlq" "硇")
("dtpy" "砭")
("dtrt" "硪")
("dty" "故")
("dubj" "劂")
("dubw" "厥")
("duce" "磙")
("duda" "磋")
("dug" "砬")
("duj" "辜")
("dujg" "鹩")
("dukg" "碚")
("duog" "碰")
("duph" "碲")
("dupy" "磅")
("duxx" "磁")
("dvcq" "厩")
("dvfh" "肆")
("dviy" "碌")
("dwag" "砼")
("dwfh" "奉")
("dwgd" "奏")
("dwgi" "硷")
("dwgu" "磴")
("dwi" "仄")
("dwiu" "泰")
("dwjf" "春")
("dwjj" "蠢")
("dwkg" "％")
("dwtu" "秦")
("dwvf" "舂")
("dwwm" "赝")
("dwwy" "雁")
("dwyg" "碓")
("dwyo" "礁")
("dxaw" "龚")
("dxbf" "聋")
("dxdf" "砻")
("dxff" "垄")
("dxjh" "砩")
("dxv" "龙")
("dxxn" "砒")
("dxye" "袭")
("dybt" "礅")
("dycq" "硫")
("dyi" "太" "丈")
("dyna" "碥")
("dynt" "戍")
("dynu" "态")
("dyt" "矿")
("dywf" "碎")
("eafm" "腻")
("eag" "肛")
("eaiy" "胨")
("eajd" "膜")
("eajg" "腊")
("eape" "朦")
("ebbh" "郛")
("ebcy" "服")
("ebf" "孕" "孚")
("ebnn" "乳")
("ecag" "胫")
("eckg" "胎")
("ecla" "戤")
("eclf" "盈")
("ecn" "肥")
("edcy" "肱")
("edfn" "胯")
("edjd" "腓")
("edjn" "腌")
("edmd" "腼")
("edmy" "须")
("edwd" "腠")
("edxn" "胧")
("edyy" "肽")
("eead" "貘")
("eebg" "脬")
("eedj" "貊")
("eeee" "月")
("eeft" "豺")
("eeg" "朋")
("eemk" "豳")
("eeou" "燹")
("eeqg" "鹏")
("eeqy" "豹")
("eer" "豸")
("eerp" "邈")
("eerq" "貌")
("eet" "肜")
("eetk" "貉")
("eetx" "貔")
("eevk" "貂")
("eews" "貅")
("eey" "豚")
("efcb" "脚")
("efcy" "肢")
("efg" "肚")
("efh" "肝")
("efhm" "虢")
("efjh" "肼")
("efkc" "臌")
("efke" "膨")
("efmf" "腩")
("efnn" "肟")
("efpb" "脖")
("efqn" "朊")
("eftc" "爰")
("efwy" "肤")
("efy" "肘")
("egbn" "肫")
("egcn" "悬")
("egcu" "县")
("egd" "且")
("egef" "膊")
("egeg" "腈")
("egey" "脯")
("egig" "胚")
("egkh" "膈")
("egln" "助")
("egmh" "肺")
("egty" "豕")
("egwy" "雎")
("egxw" "胰")
("ehhy" "胩")
("ehnn" "鼐")
("ehnt" "胪")
("eipf" "膛")
("eiqn" "胱")
("eiu" "尕")
("ejgg" "胆")
("ejh" "刖")
("ejhh" "胂")
("ejlg" "腽")
("ejtg" "腥")
("ekhh" "肿")
("ekkn" "腭")
("ekks" "臊")
("ekmw" "脶")
("eldy" "胭")
("elh" "胛")
("eln" "肋")
("elny" "腮")
("elvf" "爵")
("elwy" "胁")
("emaw" "腆")
("emcy" "股")
("emgk" "胴")
("emn" "肌")
("emqb" "觅")
("emwy" "肭")
("eniy" "脲")
("enrt" "肠")
("env" "甩")
("eoqh" "膦")
("eoy" "脒")
("epcu" "受")
("epdc" "爱")
("epey" "脓")
("epfi" "腙")
("epfq" "脘")
("epgh" "腚")
("epi" "逐")
("epqb" "腕")
("epqh" "舜")
("eprw" "膑")
("epvg" "胺")
("epwa" "腔")
("epwf" "膣")
("eqay" "胝")
("eqdb" "脆")
("eqkg" "朐")
("eqnn" "胞")
("eqqb" "胸")
("eqsy" "脎")
("eqwy" "肷")
("ercy" "胍")
("eriy" "腺")
("ermg" "鹞")
("ermi" "繇")
("ermp" "遥")
("ertf" "脾")
("eset" "彩")
("esfi" "膘")
("esu" "采")
("esvg" "腰")
("eswi" "膝")
("etay" "胀")
("etgg" "胜")
("ethf" "胙")
("etjt" "腹")
("etkg" "胳")
("etn" "乃")
("etnh" "用")
("ettt" "彡")
("euah" "胼")
("eudc" "腾")
("eudf" "塍")
("eudi" "滕")
("eudk" "膳")
("eudv" "媵")
("eudy" "朕")
("eufh" "胖")
("eujn" "臆")
("eukq" "脱")
("eupk" "膪")
("eupy" "膀")
("euqy" "胶")
("evep" "腿")
("evf" "妥" "舀")
("evfp" "腱")
("evwy" "腴")
("ewet" "胗")
("ewfc" "脍")
("ewgi" "脸")
("ewgj" "腧")
("ewwf" "脞")
("exdu" "奚")
("exjg" "脂")
("eybh" "脑")
("eyfg" "脏")
("eyi" "及")
("eyjh" "脐")
("eylg" "膻")
("eymn" "肮")
("eyn" "肪")
("eyni" "脉")
("eynw" "胲")
("eyuo" "臁")
("eywf" "腑")
("eywy" "腋")
("eyxy" "臃")
("fadn" "堪")
("faet" "霰")
("fafe" "霸")
("fafg" "坩")
("faj" "卉")
("fajv" "堰")
("fakd" "哉")
("fakg" "域")
("falk" "载")
("falw" "戴")
("famu" "贲")
("fans" "堞")
("fasi" "栽")
("fawk" "塔")
("fawy" "截")
("faye" "裁")
("fbh" "邗")
("fbn" "地")
("fcbh" "却")
("fclf" "盍")
("fcln" "动" "劫")
("fcnd" "翅")
("fcpi" "运")
("fcrc" "魂")
("fctd" "埃")
("fcu" "支" "去")
("fcuu" "云")
("fdfe" "震")
("fdfn" "垮")
("fdjd" "霏")
("fdjn" "埯")
("fdlb" "雳")
("fdln" "坜")
("fdmj" "需")
("fdmm" "颥")
("fdmy" "顸")
("fdnt" "城")
("fdri" "塬")
("fdxn" "垅")
("feef" "霾")
("feeg" "堋")
("fefy" "埒")
("feyy" "圾")
("ffcy" "坛")
("fff" "圭")
("ffff" "土")
("fffy" "封")
("ffhg" "埴")
("ffhw" "填")
("ffhy" "卦")
("ffiw" "款")
("ffnb" "雩")
("ffnn" "圬")
("ffnu" "恚")
("fftj" "堵")
("ffu" "寺")
("ffuk" "墙")
("fgcf" "垤")
("fgef" "博")
("fgey" "埔")
("fgfh" "圩")
("fgg" "二")
("fggh" "干")
("fgh" "十")
("fghy" "寸" "雨")
("fgig" "坯")
("fgiy" "坏")
("fgjg" "垣")
("fgjq" "埂")
("fgkh" "塥")
("fgog" "垭")
("fguh" "坪")
("fhag" "墟")
("fhat" "越")
("fhbc" "趣")
("fhcy" "坡")
("fheg" "趄")
("fhf" "直")
("fhfh" "矗")
("fhfk" "赶")
("fhg" "址")
("fhgj" "趔")
("fhhi" "赴")
("fhik" "趟")
("fhk" "亍")
("fhkg" "坫")
("fhlf" "盐")
("fhnh" "赳")
("fhnt" "垆")
("fhnv" "起")
("fhqi" "赵")
("fhqv" "趋")
("fhtm" "趱")
("fhu" "走")
("fhuw" "趑")
("fhvk" "超")
("fhwe" "趁")
("fhwm" "颠")
("fhwu" "真")
("fief" "霄" "霪")
("figh" "霈")
("fii" "未")
("fitv" "嫠")
("fiu" "示")
("fivs" "墚")
("fiye" "裘")
("fiyi" "求")
("fiyp" "逑")
("fiyt" "救")
("fjat" "戟")
("fjeg" "朝")
("fjfg" "埋")
("fjfh" "韩")
("fjfy" "埘")
("fjgg" "坦")
("fjgh" "堤")
("fjgp" "遘")
("fjgq" "觏")
("fjh" "刊")
("fjhh" "坤")
("fjj" "亓")
("fjk" "井")
("fjkg" "＃")
("fjlc" "墁")
("fjng" "塌")
("fjpk" "进")
("fjqr" "埸")
("fjtn" "乾")
("fjwf" "斡")
("fjwn" "翰")
("fkdm" "颉")
("fkeu" "袁")
("fkf" "吉")
("fkgg" "埕")
("fkh" "圳")
("fkhk" "露")
("fkkb" "酃")
("fkmw" "埚")
("fkmy" "埙")
("fkuc" "鼓")
("fkue" "彭")
("fkuf" "鼙")
("fkuh" "瞽")
("fkuk" "嘉" "喜")
("fkun" "甏")
("fkuo" "熹")
("flqg" "雷")
("flwy" "协")
("flyn" "塄")
("fmgk" "垌")
("fmk" "击")
("fmnn" "垲")
("fmsy" "垛")
("fmud" "献")
("fmuf" "南")
("fmy" "坝")
("fmyg" "坍")
("fnbm" "堀")
("fnhc" "霞")
("fnhk" "韦")
("fnhl" "韫")
("fnhp" "违")
("fnhv" "韬")
("fnhy" "韧")
("fnih" "墀")
("fnku" "霹")
("fnmd" "磬")
("fnmj" "馨")
("fnmm" "罄")
("fnmy" "謦")
("fnn" "圯" "圮")
("fnr" "声")
("fnrt" "场")
("fnu" "志")
("fnud" "卖")
("fnuq" "觌")
("fnv" "亏")
("fnwy" "块")
("fnxn" "坭")
("fnyi" "专")
("fobc" "赧")
("fobh" "郝")
("fofj" "赭")
("fofo" "赫")
("fotj" "螫")
("foty" "赦")
("fpbf" "孛")
("fpbg" "鹁")
("fpbl" "勃")
("fpfq" "垸")
("fpgc" "彀" "觳")
("fpgn" "懿")
("fpgu" "壹")
("fpi" "过")
("fpiv" "梁")
("fplc" "毂")
("fpmb" "壳")
("fpmn" "悫")
("fpog" "壶")
("fppu" "赤")
("fpxi" "索")
("fpxn" "坨")
("fqay" "坻")
("fqb" "元")
("fqdm" "顽")
("fqkn" "鼋")
("fqky" "堍")
("fqnb" "雹")
("fqng" "坞")
("fqpv" "远")
("fqug" "均")
("fqv" "无")
("fqwy" "坎")
("frcy" "坂")
("frgk" "垢")
("frh" "圻")
("frtf" "埤")
("fryy" "坼")
("fsfg" "堙")
("fshf" "霜")
("fskg" "坷")
("fssu" "霖")
("ftbf" "孝")
("ftbt" "教")
("fte" "才")
("ftfp" "霆")
("ftgn" "考")
("fthp" "埏")
("ftjb" "都")
("ftjf" "者")
("ftjn" "翥")
("ftjo" "煮")
("ftlb" "雾")
("ftmk" "垧")
("ftnn" "圪")
("ftxb" "老")
("ftxf" "耋")
("ftxj" "耆")
("ftxn" "耄")
("ftxu" "霉")
("fueu" "丧")
("fufj" "幸")
("fug" "垃")
("fujq" "境")
("fukg" "培")
("fulj" "增")
("fulk" "啬")
("fumk" "墒")
("fuvf" "霎")
("fvey" "垠")
("fvf" "雪")
("fviy" "埭")
("fvph" "埽")
("fvqb" "霓")
("fwfj" "替")
("fwfl" "辇")
("fwfp" "逵")
("fwi" "夫")
("fwmq" "规")
("fwnd" "堠")
("fwnf" "埠")
("fwwo" "麴")
("fwwy" "赍")
("fwyc" "零")
("fwyf" "霍")
("fwyg" "堆")
("fwyn" "埝")
("fxgu" "坶")
("fxln" "坳")
("fybh" "垴")
("fybt" "墩")
("fyjj" "霁")
("fyjn" "霭")
("fyke" "壤")
("fymn" "坑")
("fyn" "坊")
("fynw" "垓")
("fype" "壕")
("fyt" "圹")
("fyu" "雯")
("fyvh" "墉")
("fyvk" "塘")
("fyy" "坟")
("gabh" "邢")
("gadw" "琪")
("gadw" "琪")
("gaet" "形")
("gahb" "琊")
("gahd" "武")
("gahg" "鹉")
("gaj" "弄")
("gajf" "型")
("gajh" "刑")
("gak" "开")
("gakg" "瑾")
("gamd" "瑛")
("gamw" "璜")
("gawy" "珙")
("gbg" "珥")
("gbkg" "、")
("gbnm" "顿")
("gbnv" "屯")
("gcfb" "郅")
("gcff" "至")
("gcfj" "到")
("gcft" "臻" "致")
("gcg" "玛")
("gdeg" "瑚")
("gdi" "天")
("gdju" "蚕")
("gdkf" "吞")
("gdmy" "顼")
("gdnu" "忝")
("gdsk" "琦")
("gdxn" "珑")
("gef" "青")
("gefc" "瑗")
("gehp" "逋")
("geht" "敷")
("gehy" "甫")
("gemq" "靓")
("gepc" "瑷")
("geph" "靛")
("geqh" "静")
("germ" "瑶")
("geu" "表")
("geyy" "琢")
("gfcy" "珐")
("gfiy" "球")
("gfk" "于")
("gflf" "盂")
("gfnh" "玮")
("gfpk" "迂")
("gfqn" "玩")
("ggcb" "琶")
("gggg" "王")
("gggt" "戋")
("gghg" "五")
("ggiy" "环")
("ggll" "一")
("ggnt" "瑟")
("ggwn" "琴")
("ggxx" "琵")
("ggyy" "珏")
("ghae" "璩")
("gham" "琥")
("ghcy" "玻")
("ghd" "正")
("ghgb" "鄢")
("ghgo" "焉")
("ghi" "下")
("ghkg" "玷")
("ghnu" "忑")
("ghnv" "丐")
("ghqo" "璨")
("ghty" "政")
("giej" "甭")
("gigb" "邳")
("gigf" "丕")
("gigh" "歪")
("gii" "不")
("gikf" "否")
("gimy" "琐")
("gipi" "还")
("giqn" "珧")
("givb" "孬")
("gjff" "墼")
("gjfg" "理")
("gjfk" "軎")
("gjgf" "亘")
("gjgh" "芈")
("gjhg" "瑁")
("gjhn" "惠")
("gjk" "丌")
("gjqi" "更")
("gjxx" "琨")
("gjyi" "璟")
("gkf" "吾")
("gkhe" "囊")
("gkhj" "蠹")
("gkhk" "璐")
("gkhs" "橐")
("gkih" "整")
("gkii" "束")
("gkij" "剌")
("gkim" "赖")
("gkip" "速")
("gkit" "敕")
("gkk" "卅")
("gkkg" "，")
("gkkk" "噩")
("gklj" "副")
("gklp" "逼")
("gkmh" "鬲")
("gkmj" "融")
("gkmn" "翮")
("gkph" "带")
("gkqi" "吏")
("gkua" "豇")
("gkub" "豌")
("gkuc" "豉")
("gkuf" "豆")
("gkup" "逗")
("gkvh" "事")
("glbj" "画")
("glf" "盏")
("glii" "柬")
("glkg" "珈")
("glpy" "琏")
("gmaj" "曹")
("gmap" "遭")
("gmdj" "瑞")
("gmfd" "再")
("gmii" "棘")
("gmij" "刺")
("gmiu" "枣")
("gmmg" "珊")
("gmmv" "璎")
("gmn" "玑")
("gmqn" "现")
("gmu" "责")
("gmwb" "邴")
("gmwi" "丙")
("gmww" "两")
("gmwy" "璀")
("gmyb" "郦")
("gmyg" "鹂")
("gmyp" "逦")
("gmyy" "丽")
("gnan" "珉")
("gndg" "琚")
("gngd" "与")
("gngw" "欤")
("gnhc" "瑕")
("gnyn" "瓦")
("godr" "严")
("goga" "戬")
("gogd" "亚")
("gogf" "垩")
("gogj" "晋")
("gogn" "恶")
("gogy" "璞")
("goi" "来" "灭")
("gomu" "赉")
("gooy" "琰")
("gpfi" "琮")
("gplh" "珲")
("gpqb" "琬")
("gpws" "琛")
("gqbg" "殛")
("gqck" "殆")
("gqeb" "殍")
("gqeg" "殂")
("gqfh" "殖")
("gqfu" "殪")
("gqfw" "麸")
("gqgt" "残")
("gqi" "歹")
("gqje" "裂")
("gqjh" "列")
("gqji" "虺")
("gqjo" "烈")
("gqjt" "☆" "★")
("gqkg" "±")
("gqkm" "殒")
("gqmc" "殁")
("gqmd" "殃")
("gqpw" "殡")
("gqqj" "殉")
("gqri" "殊")
("gqtb" "聱")
("gqtc" "骜")
("gqtd" "獒")
("gqtf" "歼")
("gqtg" "鳌")
("gqtj" "螯")
("gqtm" "赘")
("gqto" "熬")
("gqtp" "遨")
("gqtq" "鏊")
("gqtr" "殇")
("gqty" "敖")
("gquf" "殚")
("gqv" "兀")
("gqwe" "殄" "餮")
("gqwi" "殓")
("gqxb" "死")
("gqyy" "玖")
("grdf" "碧")
("grf" "百")
("grg" "珀")
("griy" "珠")
("grqc" "瑰")
("gsh" "玎")
("gsi" "末")
("gskg" "珂")
("gssy" "琳")
("gtfh" "珩")
("gtfm" "瓒")
("gtkg" "珞")
("gtln" "璁")
("gtu" "麦")
("gty" "玫")
("guhk" "平")
("gujh" "璋")
("guwb" "郏")
("guwi" "夹")
("guwm" "颊")
("gvhv" "妻")
("gvtq" "瑙")
("gway" "玳")
("gwet" "珍")
("gwgj" "瑜")
("gwvn" "玢")
("gwyc" "玲")
("gxfi" "纛")
("gxgd" "互")
("gxgu" "毒")
("gxiu" "素")
("gxwi" "夷")
("gybc" "璃")
("gycq" "琉")
("gygg" "斑")
("gyi" "玉")
("gyiy" "琼")
("gytg" "班")
("gyth" "璇")
("gyve" "琅")
("gyvk" "瑭")
("gyy" "玟")
("haag" "虐")
("haep" "遽")
("hagg" "眶")
("hagw" "瞒")
("hakd" "虞")
("halg" "瞄")
("halv" "虏")
("hame" "彪")
("hamv" "虎")
("hani" "虑")
("haog" "虚")
("haqq" "觑")
("haqy" "眍")
("hav" "虍")
("hayi" "虔")
("hcdm" "颇")
("hci" "皮")
("hckg" "眙")
("hcrh" "眸")
("hcu" "攴")
("hcwt" "睃")
("hdff" "睚")
("hef" "肯")
("heph" "瞬")
("hesy" "睬")
("hfcl" "瞌")
("hfcy" "歧")
("hffg" "眭")
("hftj" "睹")
("hfwf" "睦")
("hgbn" "盹")
("hgeg" "睛")
("hgfh" "盱")
("hghn" "眄")
("hgmg" "凸")
("hgoy" "睐")
("hgvh" "睫")
("hhgg" "上")
("hhhg" "止")
("hhhh" "目")
("hhll" "丨")
("hhu" "卡")
("hhwc" "矍")
("hhwn" "氍")
("hhwy" "瞿")
("hhxn" "眦")
("hhy" "卜")
("hich" "督")
("hicy" "叔")
("hidf" "颦")
("hidm" "频")
("hipf" "瞠")
("hiqn" "眺")
("hir" "步")
("hitt" "眇")
("hjg" "旧")
("hjj" "卓")
("hjsu" "桌")
("hkat" "战")
("hkf" "占")
("hkmq" "觇")
("hknn" "乩")
("hkou" "点")
("hlnf" "卣")
("hlqa" "鹾")
("hlqi" "卤")
("hmu" "贞")
("hnan" "眠")
("hnbt" "瞰")
("hndm" "颅")
("hndn" "鼎")
("hne" "卢")
("hnqg" "鸬")
("hntk" "♀")
("hnty" "瞩")
("hnu" "忐")
("hoqh" "瞵")
("hoy" "眯")
("hpdk" "瞎")
("hpgf" "壑")
("hpgh" "睿")
("hpju" "瞑")
("hpqn" "眈")
("hqce" "餐")
("hqco" "粲")
("hqdy" "瞻")
("hqqy" "眵")
("hqvh" "睁")
("hrtf" "睥")
("hsfi" "瞟")
("hsh" "盯")
("htgf" "睡")
("htoy" "瞅")
("htpy" "眨")
("hujf" "瞳")
("huxt" "睇")
("hvey" "眼")
("hvhc" "瞍")
("hvqn" "睨")
("hwbc" "龄")
("hwbe" "龈")
("hwbf" "龌")
("hwbg" "龃")
("hwbh" "龊")
("hwbj" "齿")
("hwbk" "龉" "龆")
("hwbn" "龅")
("hwbx" "龀" "龇")
("hwby" "龋")
("hwgd" "睽")
("hwgi" "睑")
("hwgu" "瞪")
("hwu" "具")
("hwvn" "盼")
("hwyg" "睢")
("hwyo" "瞧")
("hxdf" "砦")
("hxff" "些")
("hxmu" "赀")
("hxn" "此")
("hxqe" "觜")
("hxsu" "柴")
("hxwy" "雌")
("hxxi" "紫")
("hxyf" "訾")
("hyxy" "眩")
("iada" "漭")
("iadn" "湛")
("iadr" "澌")
("iadw" "淇")
("iafg" "泔")
("iag" "江")
("iagn" "懑")
("iagw" "满")
("iajd" "漠")
("iaky" "灌")
("iamw" "潢")
("ian" "汇")
("iann" "泄")
("ians" "渠" "渫")
("iapi" "潆")
("iapl" "涝")
("iapy" "滢")
("iaqg" "鸿")
("iaqy" "沤")
("iasu" "柒")
("iatq" "浇")
("iavj" "潇")
("iavn" "沏")
("iawn" "港")
("iawy" "洪")
("ibcc" "滠")
("ibg" "洱")
("ibib" "涵")
("ibk" "凼")
("ibln" "泐")
("ibn" "池")
("ibwt" "滁")
("icag" "泾")
("icde" "渗")
("iceh" "涌")
("icfh" "泽")
("ickg" "治")
("icwt" "浚")
("icwy" "滩")
("icy" "汉")
("icyy" "汊")
("ideg" "洧" "湖")
("idff" "涯" "溽")
("idg" "沽")
("idhc" "滟")
("idhh" "沣")
("idiu" "尜")
("idjn" "淹")
("idln" "沥")
("idmd" "湎")
("idri" "源")
("idtf" "涛")
("idu" "尖")
("idui" "潦")
("idwt" "溱")
("idxn" "泷")
("idyy" "汰")
("iebg" "浮")
("iecn" "淝")
("ief" "肖")
("iegg" "沮")
("iejh" "削")
("iepd" "逍")
("ietf" "淫")
("ievg" "滔")
("iexd" "溪")
("ieyy" "汲" "涿")
("ifae" "灞")
("ifcl" "溘")
("ifcy" "法")
("ifdj" "濡")
("iff" "尘")
("iffg" "洼")
("ifh" "汗" "汁")
("ifhw" "滇")
("ifje" "潮")
("ifjn" "瀚")
("ifke" "澎")
("ifkf" "澍")
("ifkg" "洁")
("ifnd" "渎")
("ifnn" "污")
("ifpl" "渤")
("ifqn" "沅")
("iftj" "渚")
("ifwj" "潜")
("igbn" "沌")
("igdn" "添")
("igef" "溥")
("igey" "浦")
("igg" "汪")
("ighn" "沔")
("igjg" "洹")
("igkg" "浯")
("igkh" "滞")
("igki" "涑")
("igkm" "濑")
("igkw" "漱")
("igmh" "沛")
("igmj" "漕")
("igmy" "渍")
("igoy" "涞")
("igqj" "洌")
("igsy" "沫")
("igt" "浅")
("igtg" "≤")
("iguv" "清")
("iguw" "浃")
("ihah" "滹")
("ihan" "滤")
("ihcv" "婆")
("ihcy" "波")
("ihg" "泪")
("ihgf" "＜")
("ihic" "淑")
("ihim" "濒")
("ihit" "渺" "涉")
("ihjh" "淖")
("ihkg" "沾")
("ihmy" "浈")
("ihnt" "泸")
("ihqg" "瀣")
("ihty" "小")
("ihwy" "濉")
("iieg" "消")
("iiii" "水")
("iiiu" "淼")
("iikg" "～")
("iimk" "淌")
("iiqn" "洮")
("iite" "裟")
("iitg" "鲨")
("iitr" "挲")
("iitt" "沙")
("iitv" "娑")
("ijai" "瀑")
("ijf" "沓")
("ijg" "汨" "汩")
("ijlc" "漫")
("ijlg" "温")
("ijng" "溻")
("ijog" "湿")
("ijqn" "渴")
("ijsf" "℃")
("ijte" "涅")
("ijtl" "滥")
("ijxx" "混")
("ijy" "浊")
("ijym" "灏")
("ikeg" "涓")
("ikhk" "潞")
("ikhm" "溃")
("ikhy" "浞")
("ikjn" "渑")
("ikkn" "漶")
("ikks" "澡")
("ikmw" "涡")
("ildg" "涸")
("ildy" "洇")
("ileg" "渭")
("iley" "溷")
("ilfh" "涠")
("ilg" "泗")
("ilgj" "淠")
("ilkg" "洄")
("ilpy" "涟")
("ilrh" "渐")
("ilwy" "泅")
("ilxi" "漯")
("imau" "澧")
("imcy" "没")
("imdj" "湍")
("imdy" "泱")
("imeg" "滑")
("img" "油")
("imgk" "洞")
("imgt" "溅")
("imh" "汕")
("imjh" "测")
("imkf" "尚")
("imkg" "沿")
("imkn" "氅")
("imkt" "敞")
("imwn" "涔")
("inan" "泯")
("inbb" "潺")
("inbt" "澉")
("infh" "汛")
("infy" "漏")
("ingf" "渥")
("inhg" "湄")
("inmj" "涮")
("inn" "汜")
("inro" "烫")
("inrt" "汤")
("intt" "泌")
("inty" "泼")
("inwy" "濯")
("inxn" "泥")
("iny" "沁")
("iolw" "瀵")
("iooy" "淡")
("ipaw" "黉")
("ipbf" "学")
("ipey" "浓")
("ipfc" "尝")
("ipfi" "淙")
("ipfq" "浣")
("ipgg" "渲" "泻")
("ipgh" "淀")
("ipgw" "演")
("ipiu" "泶")
("ipjh" "渖")
("ipju" "溟")
("ipke" "裳")
("ipkf" "堂")
("ipkh" "常")
("ipkm" "赏")
("ipkq" "党")
("ipkr" "掌")
("ipks" "棠")
("iplh" "浑")
("ipmn" "沉")
("ipmq" "觉")
("ipnn" "涫")
("ipqe" "ν" "σ" "κ" "α" "ρ" "λ" "δ" "φ" "θ" "ψ" "ι" "ε" "ξ" "χ" "β" "ω" "ζ" "ο" "τ" "γ" "μ" "η" "υ")
("ipqg" "鲎")
("ipqn" "沈")
("iprw" "滨")
("ipsh" "泞")
("iptk" "喾")
("ipuh" "滓")
("ipwk" "溶")
("ipws" "深")
("ipwy" "р" "и" "б" "ц" "о" "г" "с" "ш" "ч" "я" "в" "а" "ю" "ь" "ф" "м" "ж" "э" "х" "п" "й" "к" "д" "ъ" "у" "ы" "н" "з" "т" "е" "ё" "л" "щ")
("ipxn" "沱")
("iqb" "光")
("iqbh" "汹")
("iqcy" "沟")
("iqde" "淆")
("iqdh" "浠")
("iqdy" "澹")
("iqfc" "鼗")
("iqg" "淦")
("iqgg" "渔")
("iqiy" "泺")
("iqjg" "洵")
("iqkq" "浼")
("iqmd" "涣")
("iqnn" "泡")
("iqny" "耀")
("iqpl" "辉")
("iqpv" "逃")
("iqrm" "淘")
("iqtb" "泖")
("iqtj" "潴")
("iqtk" "漪")
("iqv" "兆")
("iqy" "汐")
("iqyl" "溜")
("irdf" "湃")
("irey" "派")
("irg" "泊")
("irgg" "湟")
("irgw" "浜")
("irh" "沂")
("iriy" "洙")
("irnn" "汽")
("irrh" "浙")
("iryt" "激")
("isfg" "湮")
("isfi" "漂")
("isg" "洒")
("isgg" "酒")
("ish" "汀")
("ishg" "湘")
("isjg" "渣")
("isjh" "潭")
("iskg" "河")
("isrh" "淅")
("isse" "潸")
("issv" "漤")
("issy" "溧" "淋")
("iswc" "淞")
("iswi" "漆")
("isy" "沐")
("isyy" "沭")
("itah" "洚")
("itbn" "沲")
("itdg" "活")
("itdq" "鋈")
("itdy" "沃")
("itfk" "浩")
("itfq" "洗")
("ithd" "溴")
("ithf" "省")
("ithg" "洎")
("ithj" "濞")
("ithp" "涎")
("itie" "潲")
("itij" "海")
("itkg" "洛")
("itlb" "劣")
("itlg" "洫")
("itmd" "澳")
("itnn" "汔")
("itoh" "渊")
("itol" "潘")
("itoy" "湫")
("itpy" "泛")
("itr" "少")
("itsy" "涤")
("ittn" "滗")
("iube" "溯")
("iuce" "滚")
("iudh" "洋")
("iuej" "湔")
("iufh" "泮")
("iug" "泣")
("iugg" "润")
("iugi" "澜" "漾")
("iujf" "潼")
("iujg" "涧")
("iujh" "漳")
("iukg" "涪")
("iumd" "滴")
("iupy" "滂")
("iuwl" "溢")
("iuxt" "涕")
("iuxx" "滋")
("ivcq" "溉")
("ivf" "当")
("ivfh" "津")
("ivfy" "浔")
("ivg" "汝")
("ivhc" "溲")
("iviy" "渌")
("ivkg" "洳" "沼")
("ivlg" "淄")
("ivpc" "浸")
("ivsu" "染")
("ivwo" "粱")
("ivyh" "涩")
("iwbn" "沧")
("iwef" "脊")
("iwfc" "浍")
("iwfh" "举")
("iwga" "瀹")
("iwgj" "渝")
("iwgk" "洽")
("iwgt" "潋")
("iwgu" "澄")
("iwoy" "濮")
("iwqu" "滏")
("iwtc" "溆")
("iwty" "涂")
("iwu" "兴")
("iwvl" "湓")
("iwvn" "汾")
("iwwk" "浴")
("iwxn" "沦")
("iwyc" "泠")
("iwyf" "雀" "誉")
("iwyg" "淮")
("ixcy" "泓")
("ixjh" "沸")
("ixty" "涨")
("ixuu" "溺")
("ixwy" "潍")
("iyac" "渡")
("iybc" "漓")
("iybg" "淳")
("iycq" "流" "鎏")
("iyct" "澈")
("iygg" "注")
("iyhy" "汴")
("iyjh" "浏" "济")
("iylg" "澶")
("iyly" "沩")
("iymn" "沆")
("iyni" "泳")
("iynt" "沪")
("iynx" "漉")
("iyny" "瀛")
("iyos" "滦")
("iyox" "湾")
("iype" "濠")
("iytb" "游")
("iytf" "浒")
("iyth" "漩" "洲")
("iyuo" "濂")
("iyve" "浪")
("iyvk" "溏")
("iywf" "淬")
("iywu" "淤")
("iywy" "液")
("iyxy" "泫")
("iyy" "汶")
("iyyg" "氵")
("jada" "蟒")
("jadw" "蜞")
("jafg" "蚶")
("jag" "虹")
("jagw" "螨")
("jaht" "蚜")
("jajd" "蟆")
("jajg" "蜡")
("jakg" "蜮")
("jalt" "蠛")
("jamw" "蟥")
("jans" "蝶")
("jape" "蠓")
("japs" "蝾")
("jatq" "晓" "蛲")
("jawc" "蠖")
("jawi" "暴")
("jbcu" "最")
("jblg" "蜢")
("jcef" "肾")
("jceh" "蛹")
("jcff" "坚")
("jcfg" "蛏")
("jcg" "蚂")
("jcmu" "贤")
("jcrh" "蛑")
("jcuf" "竖")
("jcxi" "紧")
("jddn" "蛎")
("jdeg" "蝴")
("jdfe" "晨")
("jdff" "蝰")
("jdg" "蛄")
("jdhh" "蚌")
("jdnt" "晟")
("jdri" "螈")
("jdwj" "蝽")
("jdwt" "螓")
("jdwu" "昃")
("jebg" "蜉")
("jefc" "暖")
("jeg" "明")
("jegg" "蛆")
("jelf" "盟")
("jepc" "暧")
("jfcb" "野")
("jfcf" "墅")
("jfcu" "昙")
("jfd" "里")
("jfdj" "蠕")
("jffg" "蛙")
("jfh" "旰")
("jfiy" "昧")
("jfj" "旱")
("jfke" "蟛")
("jfmf" "蝻")
("jftj" "暑")
("jfwy" "蚨")
("jfy" "时")
("jgcf" "蛭")
("jgdu" "昊")
("jgeg" "晴" "蜻")
("jgey" "晡")
("jgf" "旦")
("jgg" "旺")
("jghh" "韪")
("jghm" "题")
("jghu" "是")
("jghx" "匙")
("jghy" "虾")
("jgjf" "量")
("jgjn" "蟪")
("jgkg" "晤")
("jgkl" "蝠")
("jgmh" "师")
("jgmj" "螬")
("jguw" "蛱")
("jhf" "冒")
("jhh" "刂")
("jhhc" "蠼")
("jhk" "申")
("jhkg" "：")
("jhln" "勖")
("jhng" "曰")
("jhnh" "早")
("jhnr" "畅")
("jhny" "虫")
("jieg" "蛸")
("jipf" "螳")
("jiqb" "晁" "晃")
("jjai" "曝")
("jjf" "昌")
("jjgh" "蛳")
("jjjf" "晶")
("jjjj" "日")
("jjqn" "蝎")
("jjqr" "蜴")
("jjsy" "蜾")
("jkgd" "蜈")
("jkjn" "蝇")
("jkmw" "蜗")
("jlcu" "曼")
("jlf" "蛊")
("jlfj" "曙")
("jlgy" "蝈")
("jlkg" "蛔")
("jlxi" "螺")
("jmag" "蛐")
("jmdy" "映")
("jmfg" "蚺")
("jmfk" "蜩")
("jmg" "蚰")
("jmhh" "帅")
("jmhn" "愚")
("jmhp" "遇")
("jmhy" "禺")
("jmn" "虮")
("jmqn" "蚬")
("jmwy" "蚋")
("jnhc" "暇")
("jnn" "虬")
("jnpd" "遢")
("jnqk" "』" "『")
("jnv" "电")
("jnwy" "曜")
("jnxn" "昵")
("jogf" "显")
("jou" "炅")
("jovg" "蝼")
("jpgg" "暄")
("jpju" "螟" "暝")
("jplh" "晖")
("jplj" "晕")
("jpqb" "蜿")
("jpvf" "晏")
("jpxn" "蛇")
("jqbj" "昂")
("jqdy" "蟾")
("jqje" "蟓")
("jqko" "煦")
("jqkq" "晚" "冕")
("jqrj" "剔")
("jqrr" "易")
("jqtb" "昴")
("jqug" "昀")
("jqwn" "曷")
("jqwp" "遏")
("jqww" "歇")
("jrgg" "蝗" "蚯")
("jrh" "昕")
("jriy" "蛛")
("jrtf" "蜱")
("jsdm" "颗")
("jsfi" "螵")
("jsg" "晒")
("jsi" "果")
("jskg" "蚵")
("jsqq" "夥")
("jsrh" "晰" "蜥")
("jsu" "杲")
("jtdg" "蛞")
("jtdh" "蜂")
("jtdk" "蜘")
("jtfn" "蚝")
("jtfp" "蜓")
("jtga" "戥")
("jtgf" "星")
("jtgo" "曛")
("jthf" "昨" "蚱")
("jthk" "晷")
("jthn" "螅")
("jthp" "蜒")
("jtjh" "蜊")
("jtjt" "蝮")
("jtmk" "晌")
("jtnn" "虼")
("jtol" "蟠")
("jton" "蟋")
("jtrt" "蛾")
("jtuf" "蝌")
("jtxu" "晦")
("jtyj" "临")
("jtyl" "监")
("jtyq" "览" "鉴")
("judb" "蜷")
("judh" "蛘")
("judk" "蟮")
("judn" "蜣")
("juf" "昱")
("jufh" "蚪")
("jugt" "曦")
("jujf" "蝉")
("jujg" "暗")
("jujh" "蟑")
("jukq" "蜕")
("jupy" "螃")
("juqy" "蛟")
("jusg" "蝤")
("jvb" "旯")
("jvg" "归")
("jvhc" "螋")
("jvkg" "昭")
("jvko" "照")
("jwcy" "蚣")
("jwgd" "暌")
("jwgj" "蝓")
("jwgk" "蛤")
("jwjh" "蚧")
("jwty" "蜍")
("jwxf" "晔")
("jwyc" "蛉")
("jwyk" "晗")
("jwyp" "暹")
("jxe" "曳")
("jxhh" "蚓")
("jxln" "蚴")
("jxxb" "昆")
("jxxn" "蚍")
("jybc" "螭")
("jybt" "暾")
("jygg" "蛀")
("jyie" "影")
("jyim" "颢")
("jyiu" "景")
("jyiy" "晾")
("jyjh" "蛴")
("jyke" "曩")
("jyna" "蝙")
("jynn" "虻")
("jyqy" "蚁")
("jyt" "旷")
("jytb" "蝣")
("jyuo" "蠊")
("jyvb" "螂")
("jyvk" "螗")
("jyxf" "蟀")
("jyy" "蚊")
("kadk" "喏")
("kadr" "嘶")
("kafl" "嘞")
("kagg" "哐")
("kaht" "呀")
("kajn" "噶")
("kalg" "喵")
("kamh" "咂")
("kann" "呓")
("kans" "喋")
("kapl" "唠")
("kaqy" "呕" "哎")
("katq" "哓")
("kawk" "嗒" "嗬")
("kawy" "哄")
("kayk" "嚆")
("kbcc" "嗫")
("kbh" "叩")
("kbhj" "嗤")
("kbmh" "咄")
("kbnn" "吼")
("kbnt" "戢")
("kbsk" "啊")
("kcb" "邑")
("kccc" "啜")
("kccs" "嗓")
("kcep" "嗵")
("kcg" "吗")
("kckg" "！")
("kcn" "吧")
("kcqn" "吮")
("kcrh" "哞")
("kctd" "唉")
("kcwt" "唆")
("kcy" "叹")
("kdbn" "呃")
("kdff" "喹")
("kdg" "咕")
("kdgt" "喊")
("kdha" "嘎")
("kdht" "嗄" "嘁")
("kdjd" "啡")
("kdjf" "喱")
("kdln" "呖")
("kdmy" "顺")
("kdoy" "咴")
("kdpy" "哒")
("kdui" "嘹")
("kduw" "噘")
("kdwh" "唪")
("kdwt" "嗪")
("kdxn" "咙")
("kdy" "吠")
("kdyy" "呔")
("kegg" "咀")
("kelf" "嚼")
("kepc" "嗳")
("keqg" "鹃")
("keyy" "啄" "吸")
("kfam" "喷")
("kfcl" "嗑")
("kfcy" "吱")
("kfdj" "嚅")
("kffg" "哇")
("kfg" "吐")
("kfh" "叶")
("kfhw" "嗔")
("kfiy" "味")
("kfje" "嘲")
("kfke" "嘭")
("kfkg" "咭")
("kfkk" "嘻")
("kflb" "鄙")
("kfmf" "喃")
("kfoy" "哧")
("kfph" "嚏")
("kfpi" "嗦")
("kfpu" "噎")
("kfqn" "呒")
("kftb" "嘟" "哮")
("kftj" "嗜")
("kfwy" "呋" "嚯")
("kgbh" "郢")
("kgbn" "吨")
("kgdu" "吴")
("kgey" "哺")
("kgf" "呈")
("kgfh" "吁")
("kghy" "吓")
("kgig" "呸")
("kgjq" "哽")
("kgke" "囔")
("kgkg" "唔")
("kgkh" "嗝")
("kgkj" "喇")
("kgkw" "嗽")
("kgmj" "嘈")
("kgmy" "啧")
("kgnb" "号")
("kgne" "饕")
("kgog" "哑")
("kgpd" "逞")
("kgqj" "咧")
("kgqt" "嗷")
("kgty" "唛")
("kgxi" "嗉")
("kgxw" "咦")
("khae" "噱")
("khag" "嘘")
("khaj" "躇")
("kham" "唬")
("khan" "距")
("khaq" "跷")
("khas" "蹀")
("khaw" "蹒")
("khay" "躏")
("khbc" "蹑")
("khce" "踊")
("khck" "跆")
("khcs" "蹂")
("khdc" "跋")
("khdf" "蹰" "踌")
("khdg" "跖")
("khdn" "跨")
("khdw" "蹶")
("khed" "蹊")
("kheg" "啃")
("khes" "踩")
("khev" "蹈")
("khey" "趿")
("khff" "跬")
("khfw" "趺")
("khga" "趼")
("khgm" "贵")
("khgp" "遣" "遗")
("khgt" "践")
("khhc" "跛")
("khhg" "趾")
("khhj" "踔")
("khhy" "咔")
("khij" "踏")
("khiq" "跳")
("khjn" "蹋")
("khjr" "踢")
("khjs" "踝")
("khk" "中")
("khks" "躁")
("khlf" "盅")
("khlj" "躅")
("khlk" "跏")
("khme" "蹦")
("khmg" "跚")
("khmj" "踹")
("khms" "跺")
("khnd" "踞")
("khnn" "跽")
("khnu" "忠")
("khoc" "躞")
("khoy" "蹼")
("khph" "蹿")
("khpi" "踪")
("khpx" "跎")
("khqb" "跪")
("khqi" "跞")
("khqn" "跑")
("khqy" "趵")
("khrm" "踬")
("khrw" "跌")
("khtd" "跃")
("khtf" "踵")
("khtg" "鹭")
("khtk" "踟" "路")
("khtl" "蹯")
("khtm" "躜")
("khtp" "跹")
("khtq" "跣")
("khty" "踽")
("khu" "足")
("khua" "蹉")
("khub" "踯")
("khuf" "蹲")
("khuh" "蹄")
("khuj" "蹭")
("khuk" "踣")
("khuq" "跤")
("khve" "跟")
("khvn" "躐")
("khvp" "踺")
("khwb" "啮" "跄")
("khwf" "跗")
("khwu" "蹬")
("khwy" "趴")
("khxe" "嘴")
("khxf" "跸")
("khxn" "呲")
("khy" "卟")
("khya" "蹁")
("khyc" "踱")
("khye" "踉")
("khyf" "躔")
("khyj" "跻")
("khyk" "踮")
("khyn" "蹴")
("kieg" "哨")
("kihc" "啵")
("kimy" "唢")
("kiqn" "咣")
("kitt" "吵")
("kitu" "嗨")
("kjbc" "嘬")
("kjfg" "哩")
("kjhh" "呻")
("kjjg" "唱")
("kjmy" "喁")
("kjnb" "黾")
("kjqn" "喝")
("kju" "虽")
("kkcf" "骂")
("kkdk" "嚣" "器")
("kkdu" "哭")
("kkf" "吕")
("kkfb" "鄂")
("kkfg" "鹗")
("kkfm" "颚")
("kkhk" "串")
("kkhn" "患")
("kkkf" "品")
("kkkk" "口")
("kkks" "噪")
("kkln" "鼍")
("kkmb" "咒")
("klb" "另")
("kldn" "嗯")
("kldy" "咽")
("kleg" "喟")
("klfo" "嘿")
("klfy" "啭")
("klge" "喂")
("klh" "呷")
("kljh" "别")
("klkg" "咖")
("kln" "叻")
("kmak" "嗣")
("kmbh" "郧")
("kmdj" "喘")
("kmee" "嘣")
("kmfk" "啁")
("kmhj" "吊")
("kmln" "勋")
("kmmv" "嘤")
("kmn" "叽")
("kmqy" "哕")
("kmsy" "哚")
("kmu" "员")
("kmwj" "剐")
("kmwu" "呙")
("kmwy" "呐")
("kmy" "呗")
("kngf" "喔")
("kngg" "叼")
("knhh" "叫")
("knku" "噼")
("knmj" "唰")
("knty" "嘱")
("knxn" "呢")
("kny" "吣")
("kogy" "噗")
("kooy" "啖")
("kovg" "喽")
("koy" "咪")
("kpey" "哝")
("kpff" "噻")
("kpgg" "喧")
("kpgh" "啶")
("kpnm" "嘧")
("kpsh" "咛")
("kpta" "咤")
("kptk" "喀")
("kpwi" "嚓")
("kqb" "兄")
("kqdh" "唏")
("kqgj" "噜")
("kqi" "史")
("kqmd" "唤")
("kqng" "呜")
("kqnn" "咆")
("kqqy" "哆")
("kqrm" "啕")
("kqrn" "唿")
("kqrt" "吻")
("kqwy" "吹")
("kqyg" "鸣")
("kran" "唣")
("krcy" "呱")
("krdf" "嗥")
("krey" "哌")
("krh" "听")
("krrg" "啪")
("krrh" "哳")
("krtf" "啤")
("krug" "啦")
("ksfi" "嘌")
("ksg" "哂")
("ksh" "叮")
("ksjg" "喳")
("kskg" "呵")
("kssi" "噤")
("kssy" "啉")
("ksu" "呆")
("ktan" "吒")
("ktaw" "噬")
("ktgf" "唾")
("kthd" "嗅")
("kthf" "咋")
("kthg" "咱")
("kthh" "川")
("ktkg" "咯")
("ktmd" "噢")
("ktmk" "响")
("ktnn" "吃")
("ktoy" "啾")
("ktrt" "哦")
("ktuh" "呼")
("ktuy" "咚")
("kube" "嗍")
("kuda" "嗟")
("kudh" "咩")
("kuhh" "吖")
("kujg" "喑")
("kujn" "噫")
("kulj" "噌")
("kumd" "嘀")
("kuph" "啼")
("kuqy" "咬")
("kuvg" "唼")
("kuwl" "嗌")
("kvcb" "唧")
("kvcy" "呶")
("kvey" "哏")
("kvfb" "哪")
("kvhc" "嗖")
("kvij" "啸")
("kvn" "叨")
("kwbn" "呛")
("kwcn" "嗡")
("kwfc" "哙")
("kwfk" "啥")
("kwfy" "咐")
("kwgj" "喻")
("kwgk" "哈")
("kwgu" "噔")
("kwnd" "喉")
("kwqq" "嗲")
("kwsy" "咻")
("kwu" "只")
("kwvn" "吩")
("kwvt" "咿")
("kwwf" "唑")
("kwxf" "哗")
("kwy" "叭")
("kwyc" "呤" "噙")
("kwyg" "唯")
("kwyn" "吟")
("kwyo" "噍")
("kxey" "喙")
("kxhh" "吲")
("kxln" "呦")
("kxn" "叱")
("kxqy" "哟")
("kxxf" "哔")
("kxxg" "咝")
("kxxn" "吡")
("kxxr" "喈")
("kxy" "吆")
("kybh" "哼")
("kyce" "唷")
("kyg" "唁")
("kyjh" "哜")
("kyke" "嚷")
("kymn" "吭")
("kynd" "唳")
("kyni" "咏")
("kynw" "咳")
("kyop" "㈩" "㈤" "㈦" "㈠" "㈣" "㈨" "㈢" "㈥" "㈧" "㈡")
("kype" "嚎")
("kyss" "嘛")
("kytd" "嗾")
("kyvb" "啷")
("kywf" "啐")
("laag" "轼")
("lafc" "羁")
("lbd" "囝")
("lbnn" "辄")
("lcag" "轻")
("lccc" "辍")
("lccu" "轰")
("ldbn" "轭")
("ldd" "固")
("lded" "囿")
("ldf" "罟")
("ldg" "轱")
("ldi" "因")
("ldjd" "罪")
("ldjn" "罨")
("ldnu" "恩")
("ldsk" "畸")
("ldtf" "畴")
("ldwd" "辏")
("ldy" "畎")
("lef" "胃")
("lfco" "罴")
("lfcu" "罢")
("lffg" "畦")
("lfh" "轩")
("lfhf" "置")
("lfke" "辕")
("lfmf" "罱")
("lfnh" "围")
("lfny" "转")
("lfod" "默" "黩")
("lfoe" "黪")
("lfof" "墨")
("lfoi" "黥")
("lfoj" "黯")
("lfok" "黠")
("lfol" "黝")
("lfom" "黜")
("lfon" "黔")
("lfoq" "黟")
("lfot" "黢")
("lfou" "黑")
("lfqv" "园")
("lfte" "团")
("lftj" "署")
("lfuf" "圉")
("lgbn" "囤")
("lgcf" "轾")
("lged" "圊")
("lgeu" "畏")
("lgey" "辅" "圃")
("lghf" "罡")
("lgiu" "罘")
("lgjj" "畀")
("lgkd" "圄")
("lgkl" "辐")
("lgmw" "辆")
("lgnh" "车")
("lgyi" "国")
("lhjj" "罩")
("lhng" "四" "皿" "囗")
("lhnh" "甲")
("lhnt" "轳")
("ljxx" "辊")
("lkbg" "辑")
("lkcf" "驾")
("lkd" "回")
("lkg" "加")
("lklu" "○")
("lkmi" "圆")
("lkmu" "贺")
("lkpd" "迦")
("lksk" "哿")
("lksu" "架")
("lkwy" "轵")
("lkye" "袈")
("llb" "男")
("llge" "圜")
("llll" "田")
("llln" "勰")
("llop" "⑥" "⑤" "④" "③" "⑩" "⑨" "②" "①" "⑧" "⑦")
("llvl" "嬲")
("lmg" "轴")
("lmun" "辋")
("lmyx" "π")
("lnae" "辗")
("lnn" "轧")
("lnu" "思")
("lnwy" "罹")
("loqh" "辚")
("lpdk" "辖")
("lpk" "连")
("lpqb" "畹")
("lpv" "边")
("lqiy" "轹")
("lqju" "蜀")
("lqpi" "逻")
("lqre" "囫")
("lqu" "罗")
("lqwy" "软")
("lqyg" "鸭")
("lrcy" "畈")
("lrff" "堑")
("lrh" "斩")
("lrjf" "暂")
("lrkg" "）" "（")
("lrqf" "錾")
("lrsu" "椠")
("lrwy" "轶")
("lsh" "町")
("lsi" "困")
("lskg" "轲")
("ltdj" "轿")
("ltkg" "略" "辂")
("ltn" "力")
("ltuh" "轷")
("ltui" "图")
("lty" "畋")
("ludb" "圈")
("lufh" "畔")
("lujf" "疃")
("lulj" "罾")
("luqy" "较")
("lvd" "囡")
("lvkg" "轺")
("lvlg" "辎")
("lvn" "轨")
("lvyy" "轫")
("lwet" "畛" "轸")
("lwgg" "辁")
("lwgj" "输")
("lwi" "囚" "办")
("lwjj" "界")
("lwxn" "轮")
("lwxv" "囵")
("lwyc" "囹")
("lxiu" "累")
("lxxn" "毗")
("lyct" "辙")
("lyf" "詈")
("lyjj" "罚")
("lynx" "辘")
("mad" "曲")
("madt" "贼")
("mafw" "嵌")
("maht" "岈")
("maiu" "岽")
("mapl" "崂")
("maps" "嵘")
("maqy" "岖")
("mawu" "典")
("mbh" "邮")
("mcb" "岜")
("mcfh" "峄")
("mci" "凤")
("mckg" "贻")
("mcu" "殳")
("mcwt" "峻")
("mdeg" "贿")
("mdf" "岩")
("mdfe" "赈")
("mdff" "崖")
("mdfj" "岸")
("mdg" "岵")
("mdgt" "崴")
("mdi" "央")
("mdjm" "颛")
("mdjn" "崦")
("mdlf" "盎")
("mdmp" "遄")
("mdou" "炭")
("mdqg" "鸯")
("mdsk" "崎")
("medg" "骷")
("medp" "髓")
("meef" "崩")
("mef" "骨" "胄")
("mejs" "髁")
("melj" "髑")
("memc" "骰")
("meov" "髅")
("mepk" "髂")
("mepq" "髋")
("mepw" "髌")
("meqg" "鹘")
("meqy" "骶")
("merf" "髀")
("merk" "骺")
("metk" "骼")
("mewj" "骱")
("meyu" "岌")
("meyw" "骸")
("mfcy" "岐")
("mfd" "冉")
("mffy" "峙")
("mfhm" "巅")
("mfiy" "赇")
("mfkd" "周")
("mfky" "雕")
("mfnd" "赎")
("mftj" "赌")
("mftt" "财")
("mgah" "赋" "岍")
("mgef" "赙")
("mgkd" "同")
("mgng" "屿")
("mgoy" "崃")
("mgqi" "夙")
("mgt" "贱")
("mguw" "峡")
("mhdf" "帱")
("mhfh" "帏")
("mhgl" "幅")
("mhgm" "帻")
("mhhc" "帔")
("mhhk" "帖")
("mhhm" "帧")
("mhjc" "幔")
("mhjh" "帽")
("mhjq" "幌")
("mhk" "巾")
("mhkg" "贴")
("mhkw" "帜")
("mhly" "帼")
("mhmy" "帆")
("mhn" "冂")
("mhnf" "幄")
("mhng" "由")
("mhny" "贝")
("mhoy" "幞")
("mhrg" "帕")
("mhrw" "帙")
("mhtl" "幡")
("mhty" "帐")
("mhuf" "幢")
("mhuj" "幛")
("mhwy" "帷")
("mieg" "峭")
("miwe" "嵴")
("mjh" "则")
("mjqr" "赐")
("mjvf" "岿")
("mkpd" "迥")
("mkqn" "贶")
("mldf" "崮")
("mlh" "岬")
("mlnu" "崽")
("mlrj" "崭")
("mmg" "岫")
("mmgd" "册")
("mmgj" "删")
("mmgk" "峒")
("mmgq" "兕")
("mmhg" "凹")
("mmmm" "山")
("mmqn" "岘")
("mmqu" "岗" "岚")
("mmrm" "罂")
("mmvf" "婴")
("mmvg" "鹦")
("mnan" "岷")
("mnb" "岂")
("mnbm" "崛")
("mnhg" "嵋")
("mnjh" "剀")
("mnmn" "凯")
("mnmq" "觊")
("mnn" "屺")
("mnyu" "赆")
("mooy" "赕")
("moqh" "嶙")
("movg" "嵝")
("mpd" "迪")
("mpfi" "崇")
("mpgg" "贮")
("mpwa" "崆")
("mqb" "见")
("mqcy" "购")
("mqde" "崤")
("mqdy" "赡")
("mqhw" "飓")
("mqi" "风" "冈")
("mqjg" "峋")
("mqjh" "刚" "刿")
("mqkg" "岣")
("mqoo" "飚")
("mqqi" "网")
("mqqn" "飑")
("mqtb" "峁")
("mqu" "岁")
("mqvc" "飕")
("mqvh" "峥")
("mrcy" "贩")
("mrgd" "凰")
("mrqc" "嵬")
("msjh" "剁")
("mskf" "岢")
("msu" "朵")
("msvg" "崾")
("mswc" "崧")
("mtay" "账")
("mtdh" "峰")
("mtdj" "峤")
("mtkg" "赂")
("mtn" "几")
("mtnn" "屹")
("mtpy" "贬")
("mtrt" "峨")
("mtuq" "嵊")
("mtvc" "巍")
("mty" "败")
("muda" "嵯")
("mujh" "嶂")
("mukg" "赔")
("mulj" "赠")
("muvo" "赚")
("muxx" "嵫")
("muyn" "罔")
("mwfi" "赊")
("mwgj" "嵛")
("mwgu" "嶝")
("mwi" "内")
("mwwi" "肉")
("mwwk" "峪")
("mwyc" "岭")
("mwyf" "崔")
("mwyn" "岑")
("mxth" "嶷")
("mybg" "崞")
("myd" "丹")
("myet" "彤")
("myfg" "赃")
("myi" "凡")
("mymk" "嵩")
("mynw" "赅")
("naei" "展")
("nagw" "惬")
("naj" "异" "羿")
("najg" "惜")
("nalh" "懵")
("nanv" "屉")
("naqy" "怄")
("natf" "懂")
("natn" "愍")
("nav" "民")
("nawc" "殿")
("nawe" "臀")
("nayq" "慌")
("nbbb" "孱")
("nbcc" "慑")
("nbmk" "屈")
("nbsk" "屙")
("nbtn" "憨")
("nbty" "敢")
("ncde" "惨")
("ncfg" "怪")
("ncfh" "怿")
("nckg" "怡")
("ncwt" "悛")
("ndae" "惰")
("ndd" "居")
("nddy" "恹")
("ndg" "怙")
("ndgn" "憾")
("ndjd" "悱")
("ndjh" "剧")
("ndmh" "怖")
("ndnn" "忧")
("ndoy" "恢")
("nfam" "愤")
("nfci" "层")
("nfcl" "恸")
("nfcy" "忮" "怯")
("nfd" "丑")
("nfdj" "懦")
("nffy" "恃")
("nfhw" "慎")
("nfif" "尉")
("nfin" "慰")
("nfio" "熨")
("nfpb" "悖")
("nfpk" "迅")
("nfqn" "怃")
("nftj" "屠")
("nfu" "导")
("nfuf" "悻")
("nfy" "忖")
("ngcf" "屋")
("ngd" "刁")
("ngeg" "情")
("nghg" "怔")
("ngiy" "怀")
("ngjg" "恒")
("ngkd" "司")
("ngkg" "悟")
("ngki" "悚")
("ngkm" "懒")
("ngnm" "恻")
("nguh" "怦")
("ngxi" "愫")
("nhd" "眉")
("nhda" "戕")
("nhdd" "奘")
("nhde" "爿")
("nhef" "胥")
("nhfp" "遐")
("nhi" "疋")
("nhjh" "悼")
("nhju" "蛋")
("nhkm" "愦")
("nhqg" "鹛")
("nhty" "收")
("nhwy" "惧")
("nhyq" "疏")
("nied" "屑")
("nieg" "悄")
("nii" "尿")
("nimk" "惝")
("niqn" "恍")
("nirh" "犀")
("njcf" "悭")
("njfg" "悝")
("njfh" "悍")
("njgg" "怛")
("njlc" "慢")
("njlg" "愠")
("njqr" "惕")
("njtg" "惺")
("njyi" "憬")
("nkcn" "悒")
("nkhh" "忡")
("nkkn" "愕")
("nkue" "臂" "襞")
("nkuf" "壁")
("nkuh" "辟")
("nkun" "甓")
("nkup" "避")
("nkuq" "鐾")
("nkur" "擘")
("nkus" "檗")
("nkuv" "嬖" "劈")
("nkuy" "璧" "譬")
("nlaw" "翼")
("nlrh" "惭")
("nlsy" "悃")
("nlyn" "愣")
("nmd" "届")
("nmdj" "惴")
("nmdy" "怏")
("nmfk" "惆")
("nmgk" "恫")
("nmhj" "刷")
("nmnn" "恺")
("nmun" "惘")
("nnaw" "巽")
("nnfg" "忸")
("nngn" "己" "巳")
("nngt" "尸")
("nnhy" "书")
("nnkd" "局")
("nnll" "乙")
("nnn" "忆")
("nnnn" "已")
("nnu" "忌")
("nnv" "乜")
("nnwy" "快")
("nnxn" "怩")
("nnyg" "羽")
("noi" "屎")
("novd" "屡")
("nplh" "恽")
("npqb" "惋")
("npqn" "忱")
("nqeh" "懈")
("nqjg" "恂")
("nqkg" "》" "《")
("nqrn" "惚")
("nrg" "怕")
("nrgg" "惶")
("nrh" "忻")
("nrnn" "忾")
("nrqc" "愧")
("nssh" "憷")
("nsyy" "怵")
("ntay" "怅")
("ntbg" "悸")
("ntcy" "发")
("ntdg" "恬")
("nte" "必")
("ntfc" "屐")
("ntfh" "忏" "忤")
("ntfn" "尾")
("ntgg" "性")
("nthf" "怍")
("nthh" "屣")
("ntji" "虱")
("ntjt" "愎")
("ntkg" "恪")
("ntky" "属")
("ntlg" "恤")
("ntmd" "懊")
("ntov" "屦")
("ntoy" "愀")
("nttt" "履")
("ntxu" "悔")
("nty" "改")
("nuak" "屏")
("nud" "习")
("nudd" "羼")
("nudu" "买")
("nuf" "翌")
("nui" "飞")
("nujf" "憧" "惮")
("nukq" "悦")
("nulj" "憎")
("nuvo" "慊")
("nuxt" "悌")
("nuyy" "悯")
("nvcq" "慨")
("nvey" "恨")
("nvkg" "怊")
("nvn" "忉")
("nvv" "尻")
("nwbn" "怆")
("nwcy" "忪")
("nwea" "戮")
("nweg" "鹨")
("nwgj" "愉")
("nwgk" "恰")
("nwya" "戳")
("nwyc" "怜")
("nwyf" "翟")
("nwyg" "惟")
("nwyo" "憔")
("nxfm" "惯")
("nxjh" "怫")
("nxv" "尼")
("nxxv" "屁")
("nybh" "恼")
("nyhk" "惦")
("nyhy" "忭" "忄")
("nyi" "尺")
("nyiy" "惊")
("nyjg" "昼")
("nykw" "咫")
("nyli" "懔")
("nynn" "忙")
("nyny" "心")
("nypi" "迟")
("nyuu" "尽")
("nyvh" "慵")
("nyvi" "慷")
("nywf" "悴" "翠")
("nywy" "以")
("oafs" "煤")
("oang" "炬")
("oanw" "炼")
("oatq" "烧")
("oawu" "粪")
("oawy" "烘")
("obg" "籽")
("ocag" "烃")
("ocbs" "糅")
("ocde" "糁")
("ocn" "粑")
("oddn" "粝")
("odeg" "糊" "煳")
("odg" "炻")
("odmy" "烦")
("odu" "类")
("odui" "燎")
("oegg" "粗")
("oelf" "爝")
("ofdj" "糯")
("ofg" "灶")
("ofnh" "炜")
("oftn" "烤")
("ogbh" "邺")
("ogbn" "炖")
("ogd" "业")
("ogeg" "精")
("ogjq" "粳")
("ogkg" "焐")
("ogmj" "糟")
("ogmw" "炳")
("ogub" "凿")
("oguc" "黻")
("ogui" "黹")
("oguy" "黼")
("ohjh" "焯")
("ohkg" "粘")
("oitt" "炒")
("ojai" "爆")
("ojfh" "焊")
("ojlc" "熳")
("ojug" "煜")
("ojy" "烛")
("okks" "燥")
("okwy" "炽")
("oldy" "烟")
("olge" "煨")
("omh" "灿" "籼")
("omkg" "炯")
("onhe" "糈")
("onrg" "熠")
("onrh" "断")
("onrt" "炀")
("onwy" "炔")
("onyu" "烬")
("oobh" "郯")
("oojh" "剡")
("oooo" "火")
("ooou" "焱")
("oou" "炎")
("opfi" "粽")
("opfq" "烷")
("opgg" "煊")
("ophk" "⒙" "⒚" "⒑" "⒘" "⒒" "⒌" "⒗" "⒐" "⒏" "⒖" "⒎" "⒊" "⒕" "⒍" "⒔" "⒛" "⒉" "⒓" "⒈" "⒋")
("opi" "迷")
("opwk" "熔")
("oqab" "粼")
("oqap" "遴")
("oqdh" "烯")
("oqdo" "燃")
("oqiy" "烁")
("oqmd" "焕")
("oqnn" "炮")
("oqvg" "焰")
("oqwy" "炊")
("oqyl" "熘")
("oqyy" "灼")
("org" "粕")
("orgg" "煌")
("osg" "粞")
("osh" "灯")
("otdh" "烽")
("otfp" "糙")
("othd" "糗")
("othf" "炸")
("othj" "糌")
("othn" "熄")
("otkg" "烙")
("otmd" "燠")
("otol" "燔")
("otuh" "烀")
("oty" "敉")
("oudh" "烊")
("ouep" "燧")
("oufg" "烂")
("oufh" "料")
("oug" "粒")
("ougo" "糕")
("oukg" "焙")
("oumk" "熵")
("ouny" "焖")
("ouxx" "糍")
("ovep" "煺")
("ovf" "娄")
("ovty" "数")
("owbn" "炝")
("owdc" "煅")
("owfc" "烩")
("ownd" "糇")
("owvn" "粉")
("owxf" "烨")
("owyk" "焓")
("oxkj" "糨")
("oygg" "炷")
("oymn" "炕")
("oyna" "煸")
("oynn" "煽")
("oynt" "炉")
("oyoc" "燮")
("oyty" "米")
("oyve" "粮")
("oyvi" "糠")
("oyvk" "糖")
("oywf" "粹")
("oyxy" "炫")
("oyyy" "灬")
("pahh" "宦")
("pajd" "寞")
("pamq" "宽")
("pbf" "字")
("pdcu" "宏")
("pdef" "宥")
("pdev" "寡")
("pdf" "宕")
("pdfe" "宸")
("pdhj" "割")
("pdhk" "害" "豁")
("pdsk" "寄")
("pdui" "寮")
("pdxb" "宠")
("pegf" "宜")
("pei" "农")
("peu" "家")
("peyu" "冢")
("pfiu" "宗")
("pfjc" "骞")
("pfje" "褰")
("pfjf" "塞")
("pfjh" "蹇")
("pfjm" "赛")
("pfjr" "搴")
("pfjs" "寨")
("pfju" "寒")
("pfjy" "謇")
("pfqb" "完")
("pfqc" "寇")
("pfqf" "冠")
("pfu" "守")
("pgcf" "室")
("pgfj" "宇")
("pghu" "定")
("pgjg" "宣")
("pgkl" "富")
("pgmw" "寅")
("pgng" "写")
("pgyu" "宝")
("phic" "寂")
("pief" "宵")
("pjdh" "幂")
("pjhj" "审")
("pjmy" "寓")
("pjuu" "冥")
("pjvf" "宴")
("pkkf" "宫")
("plbh" "郓")
("plge" "寰")
("plhc" "皲")
("plj" "军")
("pmb" "冗")
("pmf" "宙")
("pnag" "◆")
("pndq" "▲")
("pnej" "甯")
("pnhi" "寐")
("pnhk" "寤")
("pnhn" "官")
("pnhp" "逭")
("pnll" "●")
("pnrk" "〖" "】" "〗" "【")
("pntg" "■")
("pntj" "蜜")
("pntm" "密")
("pntr" "宓")
("pnwe" "寥")
("pny" "廴")
("pou" "灾")
("pppp" "之")
("pqbb" "宛")
("pqbj" "剜")
("pqky" "冤")
("pqqg" "鸩")
("prgw" "宾")
("prhj" "牢")
("prwn" "衿")
("psj" "宁")
("psu" "宋")
("ptab" "宅")
("ptfq" "宪")
("ptkf" "客")
("ptkm" "额")
("puak" "褡")
("pucc" "裰")
("pucy" "衩")
("pudf" "褥")
("pudu" "实")
("puet" "衫")
("pufh" "褂")
("pufj" "褚" "襦")
("pufy" "衬")
("puge" "裱")
("pugs" "袜")
("puhc" "被")
("puhy" "补")
("pui" "衤")
("puiv" "裆")
("puj" "宰")
("pujg" "袒")
("pujl" "褴")
("pujn" "褐")
("pujr" "裼")
("pujs" "裸")
("pukg" "裎")
("pulp" "裢")
("pumg" "袖")
("pumw" "衲")
("pund" "裾")
("punr" "褶")
("punw" "袂")
("puov" "褛")
("puqn" "袍")
("purf" "裨")
("purm" "褫")
("pusi" "襟")
("pusr" "襻")
("putd" "袄")
("putf" "衽")
("putk" "袼")
("puue" "褙")
("puuf" "袢")
("puuj" "裥")
("puvc" "寝")
("puve" "裉")
("puvk" "裙")
("puvn" "初")
("puvp" "褪")
("puwd" "袱")
("puwi" "裣")
("puwk" "袷" "裕")
("puws" "褓")
("puxj" "襁")
("puya" "褊")
("puyl" "裤")
("pvb" "宄")
("pvf" "安")
("pvsu" "案")
("pwaf" "空")
("pwan" "窍")
("pwat" "穿")
("pwav" "窃")
("pwbg" "窿")
("pwdj" "宿")
("pwdu" "突")
("pwfd" "窦")
("pwfi" "察")
("pwfj" "罕")
("pwfq" "窥")
("pwgf" "窒")
("pwgn" "窀")
("pwiq" "窕")
("pwjs" "窠")
("pwkh" "窜")
("pwkw" "窝")
("pwlb" "穷")
("pwmh" "帘")
("pwnm" "窟")
("pwov" "窭")
("pwqu" "穸")
("pwrm" "窑")
("pwry" "窳")
("pwtf" "窄")
("pwtk" "窖")
("pwtp" "窆")
("pwtq" "窗")
("pwu" "穴")
("pwuj" "窨")
("pwup" "邃")
("pwvb" "究")
("pwvk" "窘")
("pwwj" "窬")
("pwwk" "容")
("pwxb" "穹")
("pwxl" "窈")
("pwyg" "鹤")
("pxb" "它")
("pyaw" "祺")
("pybh" "祁")
("pydc" "祓")
("pydd" "禊")
("pydf" "祷")
("pydg" "祜")
("pyeg" "祖")
("pyfc" "祛")
("pyfg" "社")
("pyfk" "禧")
("pygd" "祆")
("pygl" "福")
("pyhg" "祉")
("pyhm" "祯")
("pyi" "礻")
("pyiq" "祧")
("pykq" "祝")
("pykw" "祸")
("pymq" "视")
("pyn" "冖")
("pynk" "祠")
("pynn" "礼" "祀")
("pyny" "辶")
("pypy" "神")
("pyqi" "祢")
("pyqy" "祗")
("pyrh" "祈")
("pytf" "祚")
("pyud" "祥")
("pyuf" "禅")
("pyuo" "禚")
("pyvi" "禄")
("pyye" "禳")
("pyyn" "宀")
("qadk" "锘")
("qafg" "钳")
("qahb" "铘")
("qahh" "舛")
("qahs" "桀")
("qajd" "镆")
("qajf" "昏")
("qajg" "错")
("qakg" "钷")
("qalg" "锚")
("qang" "钜")
("qant" "钺")
("qany" "铽")
("qapl" "铹")
("qatq" "铙")
("qav" "氏")
("qawc" "镬")
("qayb" "邸")
("qayg" "鸱")
("qayi" "氐")
("qbcc" "镊")
("qbg" "铒")
("qbh" "钌")
("qbhf" "眢")
("qbk" "凶")
("qblg" "锰")
("qbnu" "怨")
("qbpk" "迎")
("qbqg" "鸳")
("qbsk" "锕")
("qcb" "色")
("qcfh" "铎")
("qci" "勾")
("qcn" "钯")
("qcyy" "钗")
("qdbb" "危")
("qdcb" "郄")
("qdcy" "钹")
("qdef" "肴")
("qdeg" "铕")
("qdfa" "锛")
("qdg" "钴")
("qdhd" "锲")
("qdmb" "郗")
("qdmh" "钸" "希")
("qdmw" "欷")
("qdnt" "铖")
("qdou" "然")
("qdtf" "铸")
("qdui" "镣")
("qduw" "镢")
("qdwy" "詹")
("qdyy" "钛")
("qefc" "锾")
("qefy" "锊")
("qeg" "钥")
("qegi" "觫")
("qegl" "锄")
("qeiq" "觥")
("qej" "角")
("qejy" "触")
("qenw" "觖")
("qery" "觚")
("qet" "钐")
("qetr" "觞")
("qeuf" "斛" "觯")
("qevh" "解")
("qevj" "蟹")
("qevp" "邂")
("qfg" "钍")
("qfh" "针")
("qfhw" "镇")
("qflg" "镭")
("qftj" "锗")
("qftn" "铐")
("qftx" "铑")
("qgal" "鳓")
("qgas" "鲽")
("qgbc" "鲰")
("qgbh" "印")
("qgbn" "钝")
("qgcj" "鳋")
("qgck" "鲐")
("qgdc" "鲅")
("qgdd" "鲱")
("qgde" "鲔")
("qgdj" "鲕")
("qgdn" "鱿")
("qgdw" "鳜")
("qgeg" "锖")
("qgem" "鳐")
("qgey" "匍" "铺")
("qgf" "鱼")
("qgff" "鲑")
("qgfj" "鳍")
("qgfk" "鲒")
("qgfm" "鲼")
("qgft" "鲮")
("qgfv" "鳕")
("qgge" "鲭")
("qggh" "鲆")
("qggq" "鲠")
("qggy" "鲡")
("qghg" "钲")
("qghk" "鲇")
("qghn" "钙" "鲈")
("qgil" "盥")
("qgiy" "钚")
("qgjc" "鳗")
("qgjf" "鲣" "鲥" "鲁" "鲤")
("qgjj" "鲳")
("qgjn" "鳎")
("qgjx" "鲲")
("qgkh" "镉")
("qgkl" "匐")
("qgkn" "鳄")
("qgld" "鲴")
("qgli" "鳏")
("qgln" "鳃")
("qglp" "鲢")
("qgmk" "鲷")
("qgmu" "鳢")
("qgnj" "鲺")
("qgoh" "鳞")
("qgoy" "铼")
("qgpq" "鲩")
("qgqn" "鲍")
("qgrg" "鳇")
("qgsi" "鳔")
("qgt" "钱")
("qgti" "鲧")
("qgto" "鳅")
("qgts" "鲦")
("qgtt" "鳆")
("qgty" "稣")
("qgud" "鲜")
("qguf" "鳟")
("qguk" "鳝")
("qguq" "鲛")
("qguw" "铗")
("qgvb" "鲫")
("qgvf" "鲟")
("qgvl" "鲻")
("qgvq" "鲵")
("qgwf" "鲋")
("qgwn" "鲶")
("qgya" "鳊")
("qgyh" "鳙")
("qgyi" "鲸")
("qgyj" "鲚")
("qgyn" "鲂")
("qgyy" "钰")
("qhcy" "铍")
("qhg" "钼")
("qhkg" "钻")
("qhy" "钋" "外")
("qieg" "销")
("qigy" "玺")
("qii" "乐")
("qimy" "锁")
("qinr" "铴")
("qipf" "镗")
("qipi" "迩")
("qiqn" "铫")
("qitt" "钞")
("qiu" "尔")
("qivg" "铛")
("qjbh" "郇")
("qjcf" "铿")
("qjd" "旬")
("qjeu" "象")
("qjfg" "锂")
("qjgf" "锝")
("qjgg" "钽")
("qjh" "刈" "钊")
("qjlc" "镘")
("qjnb" "龟")
("qjqr" "锡")
("qjsy" "锞")
("qjxx" "锟")
("qkd" "句")
("qkf" "名")
("qkgg" "锃")
("qkh" "钏")
("qkhh" "钟" "锺")
("qkkg" "铝" "。")
("qkkn" "锷")
("qkln" "劬")
("qkmh" "铞")
("qkmw" "锅")
("qkqb" "免")
("qkqg" "鸲")
("qkql" "勉")
("qkqp" "逸")
("qkqq" "够")
("qkqy" "兔")
("qld" "甸")
("qldg" "锢")
("qldy" "铟")
("qlg" "钿")
("qlh" "钾")
("qlny" "锶")
("qlpy" "链")
("qlqj" "镯")
("qlqy" "锣")
("qlxi" "镙")
("qmdu" "奂")
("qmg" "铀")
("qmgk" "铜")
("qmjh" "铡")
("qmkg" "铅")
("qmnn" "铠")
("qmqy" "钢")
("qmu" "负")
("qmwy" "钠")
("qmy" "钡")
("qmyy" "钒")
("qnad" "馍")
("qnag" "馑")
("qnaq" "饶")
("qnat" "馓")
("qnbg" "饵")
("qnck" "饴")
("qndg" "锯")
("qnev" "馁")
("qnfb" "饽")
("qnfg" "钮")
("qngb" "邬")
("qngd" "乌")
("qnge" "馕")
("qngn" "饨")
("qngt" "饯")
("qnhg" "镅")
("qnjc" "馒")
("qnjh" "刨")
("qnjx" "馄")
("qnjy" "蚀")
("qnk" "饣")
("qnkm" "馈")
("qnmn" "饥")
("qnn" "钆" "钇")
("qnnk" "饲" "锔")
("qnnr" "饧")
("qnnw" "馔")
("qnpn" "馆")
("qnql" "馏")
("qnqn" "饱")
("qnqu" "馋")
("qnqv" "馅")
("qnqw" "饮")
("qnrc" "饭")
("qnrn" "饩")
("qnsg" "馇")
("qntd" "饫")
("qntf" "饪")
("qnth" "饰")
("qntk" "饷")
("qntl" "饬")
("qntt" "饿" "铋")
("qnua" "饼")
("qnuf" "馐")
("qnuq" "饺")
("qnv" "包")
("qnvc" "馊")
("qnwt" "馀")
("qnxn" "铌")
("qobx" "鬯")
("qogy" "镤")
("qooy" "锬")
("qou" "炙")
("qovg" "镂")
("qoy" "钬")
("qpey" "镓")
("qpgh" "锭")
("qpgw" "夤")
("qprw" "镔")
("qpvg" "铵")
("qpwh" "镩")
("qpwi" "镲")
("qpxn" "铊")
("qqbk" "匈")
("qqcn" "铯")
("qqcy" "钩")
("qqgj" "镥")
("qqiy" "铄")
("qqkg" "铭")
("qqng" "钨")
("qqqf" "鑫")
("qqqq" "金")
("qqrn" "锪")
("qqsy" "铩")
("qqtb" "铆")
("qqu" "爻" "多")
("qqug" "钧")
("qqvh" "铮")
("qqwy" "钦")
("qqyl" "镏")
("qqyy" "钓")
("qrcy" "钣")
("qre" "勿")
("qrg" "铂")
("qriy" "铢")
("qrjh" "刎")
("qrmh" "锦")
("qrnq" "兜")
("qrnu" "忽")
("qrqw" "锨")
("qrwy" "铁")
("qryi" "匆")
("qsaa" "弑")
("qsfi" "镖")
("qsgg" "钵")
("qsh" "钉")
("qsjh" "刹" "镡")
("qskg" "钶")
("qsu" "杀")
("qtad" "狨")
("qtaj" "猎")
("qtal" "猫")
("qtay" "獾")
("qtbh" "卯")
("qtbi" "狲")
("qtbl" "猛")
("qtbn" "犯")
("qtcg" "犸")
("qtcq" "狁")
("qtcs" "猱")
("qtct" "狻")
("qtde" "猢")
("qtdh" "锋")
("qtdi" "獠")
("qtdk" "猗")
("qtdn" "犹")
("qtdw" "獗")
("qte" "犭")
("qteg" "狙")
("qten" "锈")
("qtfc" "铥")
("qtfe" "猿")
("qtfh" "犴" "钎")
("qtfj" "猪")
("qtfk" "锆")
("qtfp" "铤")
("qtfq" "铣")
("qtfs" "橥")
("qtfv" "锸")
("qtge" "猜")
("qtgf" "锤")
("qtgg" "狂")
("qtgm" "獭")
("qtgn" "钅")
("qtgp" "逛")
("qtgw" "狭")
("qths" "镍")
("qtjf" "狸")
("qtjg" "猩")
("qtjh" "狮")
("qtjj" "猖")
("qtjs" "猓")
("qtjy" "独")
("qtke" "狷")
("qtkg" "铬")
("qtle" "猬" "猥")
("qtlh" "狎")
("qtlq" "猡")
("qtme" "猾")
("qtmy" "狈")
("qtn" "勹" "儿")
("qtnf" "狃")
("qtnh" "猸")
("qtny" "夕")
("qtop" "逖")
("qtoy" "狄" "锹")
("qtpf" "狩")
("qtps" "狞")
("qtqh" "狰" "獬")
("qtqk" "狗")
("qtqn" "狍")
("qtrt" "锇")
("qtry" "狐")
("qtsg" "猹")
("qttj" "猁")
("qtto" "獯")
("qtuj" "獐")
("qtuq" "狡" "獍")
("qtvb" "卿")
("qtve" "狠")
("qtvn" "犰")
("qtvq" "猊")
("qtwc" "狯")
("qtwd" "猴")
("qtwi" "猃")
("qtwk" "猞")
("qtwt" "狳")
("qtxf" "狴")
("qtxi" "猕")
("qtxj" "狒")
("qtyd" "狱")
("qtye" "狼")
("qtyf" "猝")
("qtyg" "狺")
("qtyt" "犷")
("qud" "匀")
("qudb" "锩")
("qufh" "钭")
("quga" "锎")
("qugd" "镁")
("qugi" "镧")
("quh" "锌")
("qujg" "锏")
("qujn" "镱")
("qujq" "镜")
("qukg" "锫")
("qukq" "锐")
("qumd" "镝")
("qun" "钔")
("quoj" "镨")
("qupy" "镑")
("quqf" "锵")
("quqy" "铰")
("qutt" "铲")
("quwl" "镒")
("quxt" "锑")
("qvbh" "邹")
("qvey" "银")
("qvf" "刍")
("qvfp" "键")
("qvg" "钕")
("qvhc" "皱" "锼")
("qvhj" "争")
("qvkg" "铷")
("qvlg" "锱")
("qvnu" "急")
("qvpc" "锓")
("qvto" "煞")
("qvwy" "雏")
("qwdc" "锻")
("qwgg" "铨")
("qwgk" "铪")
("qwgr" "镎")
("qwgu" "镫")
("qwu" "欠")
("qwwf" "锉")
("qwxf" "铧")
("qwyc" "铃")
("qwye" "镌" "飧")
("qwyg" "锥")
("qwyn" "钤")
("qxjm" "镄")
("qxkj" "镪")
("qxxr" "锴")
("qyac" "镀")
("qybt" "镦")
("qycq" "锍" "铳")
("qyd" "訇")
("qyey" "锿" "铱")
("qyi" "久" "勺")
("qyke" "镶")
("qymh" "铈")
("qymk" "镐")
("qymn" "钪")
("qyn" "钫")
("qync" "鹱")
("qyne" "袅")
("qyng" "鸟")
("qynm" "岛" "凫")
("qyno" "镳")
("qyns" "枭")
("qynx" "鸵")
("qyou" "灸")
("qytb" "孵")
("qytd" "镞")
("qyth" "镟")
("qyty" "卵")
("qyuo" "镰")
("qyve" "锒")
("qyvh" "镛")
("qyvl" "留")
("qyvm" "贸")
("qyvp" "遛")
("qyxy" "铉")
("raag" "拭")
("rab" "皂")
("radr" "撕")
("raet" "撒")
("rag" "扛")
("rajd" "摸")
("rajg" "措")
("rajv" "揠")
("ralg" "描")
("rang" "拒")
("rans" "揲")
("ranw" "拣")
("rapl" "捞")
("raqy" "抠")
("rat" "找")
("ratq" "挠")
("rawk" "搭")
("raws" "搽")
("rawy" "拱")
("rbbh" "揶")
("rbcc" "摄")
("rbcy" "报")
("rbig" "拯")
("rbmh" "拙")
("rcah" "拚")
("rcbh" "抒")
("rcbs" "揉")
("rccc" "掇")
("rccs" "搡")
("rcde" "掺")
("rceh" "捅")
("rcfh" "择")
("rci" "反")
("rckg" "抬")
("rcn" "把")
("rcpi" "返")
("rctd" "挨")
("rcwy" "摊")
("rcyi" "瓜")
("rcyj" "搔")
("rcyw" "瓞")
("rdbn" "扼")
("rdcy" "拔")
("rdfe" "振")
("rdff" "捱")
("rdfh" "拜")
("rdfi" "捺")
("rdfj" "皋")
("rdfn" "翱" "挎")
("rdg" "拓")
("rdgn" "撼")
("rdjd" "排")
("rdjn" "掩")
("rdmy" "颀")
("rdnn" "扰")
("rdpy" "挞")
("rdsk" "掎")
("rdui" "撩")
("rduw" "撅")
("rdwd" "揍")
("rdwh" "捧")
("rdxn" "拢")
("refc" "援")
("refy" "捋")
("reh" "拥")
("ren" "扔")
("repc" "授")
("rerm" "摇")
("rfcy" "技")
("rffg" "挂")
("rffy" "持")
("rfhd" "盾")
("rfhp" "遁")
("rfjf" "擀")
("rfkg" "拮")
("rfkm" "撷")
("rflg" "擂")
("rfmi" "质")
("rfny" "抟")
("rfpy" "挝")
("rfqn" "抚")
("rftn" "拷")
("rfwl" "撵")
("rfwy" "扶" "攉")
("rgbh" "邱")
("rgbv" "卮")
("rgd" "丘")
("rgdn" "掭")
("rgef" "搏")
("rgey" "捕")
("rgf" "皇")
("rghg" "扌")
("rgkd" "后")
("rgke" "攮")
("rgkg" "捂")
("rgkp" "逅")
("rgmj" "岳")
("rgpd" "遑")
("rgsy" "抹")
("rgtr" "乒")
("rguh" "抨")
("rguw" "挟")
("rgvh" "捷")
("rgwu" "兵")
("rgyu" "乓")
("rhal" "掳")
("rhan" "摅")
("rhbh" "卸")
("rhcy" "披")
("rhf" "看")
("rhfk" "年")
("rhg" "扯")
("rhhc" "攫")
("rhjh" "掉")
("rhk" "牛")
("rhkg" "拈")
("rhy" "扑")
("rhyc" "爬")
("rhyi" "爪")
("ribh" "邾")
("rieg" "捎")
("rii" "朱")
("ripq" "搅")
("ripr" "撑")
("riqn" "挑")
("ritt" "抄")
("riu" "泉")
("rivg" "挡")
("rjbc" "撮")
("rjfg" "捏")
("rjfh" "捍")
("rjgg" "担")
("rjgh" "提")
("rjhh" "抻")
("rjqn" "揭")
("rjtq" "揽")
("rjxt" "拽")
("rkbg" "揖")
("rkcn" "挹")
("rkeg" "捐")
("rkg" "扣")
("rkhy" "捉")
("rkks" "操")
("rklj" "捌")
("rkln" "拐")
("rkmy" "损")
("rkop" "⒆" "⒁" "⑹" "⒀" "⑴" "⒇" "⑾" "⑵" "⑻" "⑼" "⒅" "⑿" "⒄" "⑽" "⑺" "⑶" "⒃" "⑷" "⒂" "⑸")
("rldn" "摁")
("rlfc" "摆")
("rlge" "擐")
("rlgh" "舞")
("rlgy" "掴")
("rlh" "押")
("rlsy" "捆")
("rltk" "撂")
("rlxi" "摞")
("rmag" "缸")
("rmay" "罐")
("rmcy" "投")
("rmdj" "揣")
("rmg" "抽")
("rmhh" "罅")
("rmhj" "帛" "制")
("rmhr" "掣")
("rmk" "缶")
("rmmv" "撄")
("rmnn" "皑")
("rmnw" "缺")
("rmwy" "摧")
("rnae" "搌")
("rnan" "抿")
("rnb" "气")
("rnbm" "掘")
("rnbt" "撖")
("rnca" "氢")
("rndg" "据")
("rndq" "氪")
("rnev" "氖")
("rnfg" "扭")
("rnge" "氰")
("rngf" "握")
("rngg" "氩")
("rnjj" "氘")
("rnjl" "氲")
("rnkj" "氚")
("rnku" "擗")
("rnld" "氤")
("rnmj" "氙")
("rnn" "扎")
("rnnw" "撰")
("rnoo" "氮")
("rnpv" "氨")
("rnrg" "摺")
("rnrh" "所")
("rnrt" "扬")
("rntr" "氕")
("rntu" "氡")
("rnty" "拨")
("rnua" "摒")
("rnud" "氧")
("rnvi" "氯")
("rnwv" "氛")
("rnwy" "抉" "擢")
("rnxj" "氟")
("rnyw" "拟" "氦")
("rovg" "搂")
("rovt" "擞")
("rpd" "迫")
("rpfq" "皖")
("rpgg" "揎")
("rpk" "近")
("rplh" "挥")
("rprw" "摈")
("rpsh" "拧")
("rpvg" "按")
("rpwa" "控")
("rpwh" "撺")
("rpwi" "擦")
("rpwn" "挖")
("rpws" "探")
("rqay" "抵")
("rqbh" "抑")
("rqcc" "魑" "魃")
("rqce" "魈")
("rqcf" "魁")
("rqci" "鬼" "魅")
("rqcn" "魍")
("rqcw" "魉")
("rqgj" "撸")
("rqkg" "拘")
("rqkq" "挽")
("rqku" "搀")
("rqmd" "换")
("rqnn" "抱")
("rqoy" "掬")
("rqqw" "揿")
("rqrm" "掏")
("rqvg" "掐")
("rqvh" "挣")
("rqwy" "欣")
("rqym" "捣")
("rqyy" "的")
("rrcy" "皈" "扳")
("rrg" "拍")
("rrh" "折")
("rrhm" "搋")
("rrhy" "抓")
("rrju" "蜇")
("rrkf" "哲")
("rrkh" "踅")
("rrpk" "逝")
("rrqc" "魄")
("rrqw" "掀")
("rrrr" "白")
("rrtf" "捭")
("rryf" "誓")
("rryy" "拆")
("rsh" "打")
("rsjg" "揸")
("rtan" "托")
("rtbn" "拖")
("rtdg" "括")
("rtdj" "挢")
("rtec" "搬")
("rtfb" "郫")
("rtff" "捶")
("rtfg" "鹎")
("rtfh" "扦")
("rtfj" "卑")
("rtfk" "皓")
("rtfm" "攒")
("rtfn" "撬")
("rtfp" "挺")
("rtfv" "插")
("rtgh" "手")
("rthi" "攥")
("rthj" "擤")
("rtol" "皤" "播")
("rtoy" "揪")
("rtth" "斤")
("ruah" "拼")
("rube" "搠")
("ruda" "搓")
("rudb" "掷")
("rufg" "拦")
("rufh" "抖" "拌")
("rug" "拉")
("rujf" "撞" "掸")
("rujg" "揞")
("rukg" "掊")
("rumd" "摘")
("rumt" "撇")
("run" "扪")
("ruqy" "皎")
("rusf" "撙")
("rutk" "搁")
("ruvg" "接")
("ruvo" "搛")
("rvfb" "挪")
("rvg" "扫")
("rvhc" "搜")
("rvkg" "招")
("rvln" "抛")
("rvnc" "殷")
("rvqy" "拶")
("rvtk" "捃")
("rvyf" "垫")
("rvyg" "鸷")
("rvyi" "絷")
("rvyj" "蛰")
("rvyl" "势")
("rvym" "贽")
("rvyo" "热")
("rvyr" "挚")
("rvyy" "执")
("rwbn" "抢")
("rwfy" "拊")
("rwgd" "揆")
("rwgg" "拴")
("rwgi" "捡")
("rwgj" "揄")
("rwgk" "拾")
("rwgr" "搿")
("rwi" "失")
("rwpi" "迭")
("rwvn" "扮")
("rwvr" "掰")
("rwwf" "挫")
("rwxn" "抡")
("rwy" "扒")
("rwyc" "擒" "拎")
("rwye" "携")
("rwyg" "推")
("rwyn" "捻")
("rxey" "掾")
("rxfm" "掼")
("rxgu" "拇")
("rxjg" "指")
("rxjh" "拂")
("rxln" "拗")
("rxuu" "搦")
("rxxn" "批")
("rxxr" "揩")
("ryao" "摭")
("ryct" "撤")
("rygg" "拄")
("ryhk" "掂")
("ryi" "斥")
("ryiy" "掠")
("ryjh" "挤")
("ryke" "攘")
("rylg" "擅")
("rymk" "搞")
("rymn" "抗")
("rynd" "捩")
("ryne" "掮")
("rynt" "护")
("ryt" "扩")
("rytp" "邀")
("ryty" "敫")
("ryvk" "搪")
("rywy" "掖")
("ryxf" "摔")
("ryxl" "搐")
("saah" "械")
("sabh" "栉")
("sadd" "榧")
("sadn" "椹")
("sadw" "棋")
("safg" "柑")
("sag" "杠")
("sagg" "框")
("saiy" "栋")
("sajd" "模")
("sakg" "槿")
("samw" "横")
("sang" "柜")
("sape" "檬")
("saqy" "枢" "柩")
("satq" "桡")
("sbbh" "椰")
("sbde" "椭")
("sbf" "李")
("scbh" "杼")
("scbk" "橘")
("scbn" "懋")
("sceh" "桶")
("scfg" "柽")
("scfy" "树")
("scg" "杩")
("scn" "杷")
("scwt" "梭")
("scy" "权")
("scyy" "杈")
("sdg" "柘" "枯")
("sdgf" "橱")
("sdhd" "楔")
("sdht" "槭")
("sdln" "枥")
("sdmy" "顶")
("sdsk" "椅")
("sdtb" "梆")
("sduw" "橛")
("sdwd" "楱")
("sdwh" "棒")
("sdwj" "椿")
("sdwt" "榛")
("sdxn" "栊")
("sdyy" "杖")
("sebg" "桴")
("seci" "楹")
("seeg" "棚")
("set" "杉")
("seyy" "极")
("sfbh" "鄄")
("sfcy" "枝")
("sffg" "桂")
("sffn" "樗")
("sfg" "杜")
("sfgn" "甄")
("sfh" "杆")
("sfhg" "植")
("sfht" "樾")
("sfij" "剽")
("sfiq" "飘")
("sfiu" "柰" "票")
("sfiy" "瓢" "标")
("sfkg" "桔")
("sflg" "檑")
("sfmf" "楠")
("sfnd" "椟")
("sftj" "楮")
("sftn" "栲")
("sftt" "材")
("sftx" "栳")
("sfuk" "樯")
("sfwt" "棱")
("sfy" "村")
("sgaf" "酣")
("sgag" "醛")
("sgaj" "醋")
("sgbn" "酏")
("sgcf" "桎")
("sgct" "酸")
("sgd" "酉" "本")
("sgde" "醐")
("sgdg" "酤")
("sgdl" "醢")
("sgdy" "酞")
("sgef" "酹")
("sgfb" "酵")
("sgfc" "酝")
("sgfh" "酐")
("sgfy" "酎")
("sgg" "枉")
("sggd" "酽")
("sggy" "酾")
("sgh" "丁")
("sghe" "醵")
("sghg" "西")
("sgiy" "杯")
("sgjg" "醒" "桓")
("sgjh" "醍")
("sgjq" "梗")
("sgjx" "醌")
("sgkg" "梧" "酲")
("sgli" "楝")
("sgmj" "槽")
("sgmk" "酮")
("sgmu" "醴")
("sgmw" "柄")
("sgne" "醪" "醑")
("sgnn" "朽" "配")
("sgog" "桠")
("sgop" "醚")
("sgoy" "醭")
("sgpx" "酡")
("sgqb" "酗")
("sgqk" "酩")
("sgqn" "杌")
("sgqy" "酌")
("sgsh" "酊")
("sgt" "栈")
("sgtf" "酢")
("sgtk" "酪" "酷")
("sgto" "醺")
("sgtq" "酰")
("sgtu" "酶")
("sgty" "酥")
("sguh" "枰")
("sguk" "醅")
("sgwo" "醮")
("sgwt" "酴")
("sgwv" "酚")
("sgxj" "酯")
("sgyb" "醇")
("sgye" "酿")
("sgyf" "醉")
("sgyh" "酬")
("sgyk" "醣")
("sgyl" "醯")
("shg" "相")
("shic" "椒")
("shjh" "棹")
("shmy" "桢")
("shnt" "栌")
("shnu" "想")
("shy" "朴")
("sieg" "梢")
("siit" "桫")
("sipf" "樘")
("siqn" "桄" "桃")
("sitt" "杪")
("sivg" "档")
("siwh" "榉")
("sjf" "杳")
("sjgf" "查")
("sjj" "覃")
("sjng" "榻")
("sjsy" "棵")
("sjtl" "槛")
("sjtq" "榄")
("sjxx" "棍")
("skbg" "楫")
("skd" "可")
("skf" "杏")
("skgn" "枵")
("skkk" "榀")
("sksk" "哥")
("sksw" "歌")
("skwy" "枳")
("slh" "柙")
("slkg" "枷")
("slqy" "椤")
("slyn" "楞")
("smg" "柚")
("smgk" "桐")
("smmg" "栅")
("smmv" "樱")
("smn" "机")
("smnn" "桤")
("smqn" "枧")
("smqy" "枫")
("smu" "贾")
("smwy" "枘")
("snbt" "橄")
("sndg" "椐")
("sng" "栩")
("snhg" "楣")
("snie" "榍")
("snih" "樨")
("snn" "札" "杞")
("snrt" "杨")
("sou" "杰" "粟")
("sovg" "楼")
("spfi" "棕")
("spgg" "楦")
("spnn" "棺")
("spqn" "枕")
("sprw" "槟")
("spsh" "柠")
("spvg" "桉")
("spwf" "榨")
("spwi" "檫")
("spwk" "榕")
("spwy" "榷")
("spxn" "柁")
("sqay" "柢")
("sqcy" "构")
("sqdb" "桅")
("sqdy" "檐")
("sqef" "槲")
("sqeh" "桷")
("sqgj" "橹")
("sqiy" "栎")
("sqje" "橡")
("sqkg" "枸")
("sqqd" "樊")
("sqqr" "攀")
("sqtb" "柳")
("sqyl" "榴")
("sqyy" "杓")
("srcy" "板")
("srdf" "槔")
("srg" "柏")
("srgb" "栀")
("srh" "析")
("sriy" "株")
("srmh" "棉")
("srqc" "槐")
("srrf" "皙")
("sryt" "檄")
("sryy" "柝")
("ssbh" "郴")
("sset" "彬")
("ssfi" "禁")
("ssg" "栖")
("ssjg" "楂")
("sskg" "柯")
("ssmy" "梵")
("ssnh" "楚")
("ssou" "焚")
("ssqu" "梦")
("ssss" "木")
("sssu" "森")
("ssu" "栗")
("ssvf" "婪")
("sswv" "棼")
("ssy" "林")
("ssyx" "麓")
("stay" "枨")
("stdg" "栝")
("stdj" "桥")
("stfh" "杵" "桁")
("stfk" "梏")
("stfn" "橇")
("stfp" "梃")
("stgf" "棰")
("sthf" "柞")
("stkg" "格")
("stmf" "榭")
("stoy" "楸")
("sttt" "覆")
("stxu" "梅")
("sty" "枚")
("suda" "槎")
("sudh" "样")
("sufg" "栏")
("suh" "梓")
("sujh" "樟")
("sukk" "榈")
("supy" "榜")
("suqy" "校")
("susf" "樽")
("susy" "榇")
("suxt" "梯")
("svcq" "概")
("svey" "根")
("svf" "要")
("svfp" "楗")
("svg" "桕")
("sviy" "棣")
("svoy" "棂")
("swbn" "枪")
("swcy" "松")
("swdc" "椴")
("swfc" "桧")
("swgg" "栓")
("swgi" "检")
("swgj" "榆")
("swgu" "橙")
("swnp" "槌")
("swwy" "枞")
("swxf" "桦")
("swyc" "檎" "柃")
("swyf" "榫")
("swyg" "椎")
("swyo" "樵")
("sxey" "椽")
("sxxe" "橼")
("sxxn" "枇")
("sxxr" "楷")
("sybg" "椁")
("sycq" "梳")
("syfg" "桩")
("syfj" "槠")
("sygg" "柱")
("syi" "术")
("syiy" "椋")
("syke" "榱")
("sylg" "檀")
("syli" "檩")
("symh" "柿")
("symk" "槁")
("symn" "杭")
("syn" "枋")
("synw" "核")
("sypi" "述")
("syvb" "榔")
("tabj" "筇")
("tadc" "簸")
("tadd" "篚")
("tadk" "箬")
("tadw" "箕")
("tagf" "筐")
("tagw" "箧")
("tahp" "逄")
("tak" "升")
("takf" "笸")
("tamw" "簧")
("tamy" "筑")
("taqj" "簪")
("tav" "乇")
("tavt" "彻")
("taww" "筮")
("tayi" "长")
("tbf" "季")
("tbpv" "迤")
("tcag" "径")
("tcb" "笆")
("tcf" "笃")
("tckf" "笞")
("tcu" "么")
("tcy" "私")
("tdaf" "甜")
("tdan" "矩")
("tdas" "榘")
("tdd" "舌")
("tdga" "□")
("tdgn" "舔")
("tdgt" "箴")
("tdgu" "短")
("tdhp" "逢")
("tdi" "夭")
("tdij" "籍")
("tdjd" "徘")
("tdjh" "刮")
("tdjj" "乔")
("tdkg" "知")
("tdkj" "智")
("tdmj" "岙")
("tdnj" "稽")
("tdnm" "嵇")
("tdnn" "乱")
("tdpd" "适")
("tdqa" "舐")
("tdqg" "鸹")
("tdtf" "筹")
("tdtj" "矫")
("tdtn" "憩")
("tdtv" "矮")
("tdty" "敌")
("tdu" "矢")
("tduh" "辞")
("tdwf" "矬")
("tdwy" "雉")
("tdxb" "笼")
("tdxh" "矧")
("teae" "艨")
("teag" "舡")
("teb" "秀")
("tebg" "稃")
("tebl" "艋")
("tegg" "徂" "租")
("tegj" "艚")
("tehn" "舻")
("tei" "舟")
("teie" "艄")
("tekh" "舯")
("telb" "筋")
("telf" "盘")
("temc" "般")
("temd" "磐")
("temg" "舳")
("temh" "舢")
("temk" "船")
("temq" "舰")
("tenn" "艉")
("tepv" "透")
("tepx" "舵")
("terc" "舨")
("terg" "舶")
("term" "徭")
("tesg" "舾")
("tesk" "舸")
("tetf" "舴")
("tetp" "艇")
("teuf" "艟")
("teuh" "艏")
("tevc" "艘")
("tevg" "稻")
("tewb" "舱")
("texx" "舭")
("teym" "航")
("teyn" "舫")
("teyq" "舣")
("teyu" "笈")
("teyx" "舷")
("tfcu" "丢")
("tfd" "壬")
("tff" "竺")
("tffh" "街")
("tffu" "等")
("tffy" "待")
("tfh" "秆")
("tfhh" "行")
("tfhw" "稹")
("tfhy" "徒")
("tfj" "竿" "午")
("tfjf" "篝")
("tfk" "千")
("tfkb" "郜")
("tfkd" "靠")
("tfkf" "告")
("tfkg" "鹄" "秸")
("tfkp" "造")
("tfln" "德")
("tfnh" "毪")
("tfnj" "氆" "氇")
("tfnk" "毡")
("tfnn" "毳")
("tfno" "毯")
("tfnp" "毽")
("tfnv" "毛")
("tfpd" "廷")
("tfpk" "迁" "迕")
("tfqb" "先")
("tfqm" "赞")
("tfqp" "选")
("tfqu" "筠")
("tftj" "箸")
("tfuk" "穑")
("tfux" "乖")
("tfvw" "歃")
("tgaf" "垂")
("tgaj" "笄")
("tgd" "生")
("tgef" "箐")
("tgfj" "竽")
("tghf" "眚")
("tghg" "征")
("tghn" "惩")
("tgjf" "重")
("tgjn" "穗")
("tgjq" "筻")
("tgkh" "衙")
("tgkm" "籁")
("tgkw" "簌")
("tgll" "甥")
("tglo" "熏")
("tgmi" "策")
("tgmu" "箦")
("tgoy" "徕")
("tgr" "笺")
("tgsy" "秣")
("tguh" "秤")
("tgvi" "秉")
("thaj" "算")
("thcy" "彼")
("thd" "自")
("thdc" "篡")
("thdi" "纂")
("thdu" "臭")
("thfd" "乍")
("thfn" "怎")
("thfp" "迮")
("thgc" "版")
("thgd" "牍")
("thgf" "牌")
("thgn" "片")
("thgs" "牒")
("thgy" "牖")
("thhh" "衢")
("thhy" "徙")
("thi" "处")
("thjf" "昝")
("thkf" "咎")
("thlf" "鼾")
("thlg" "齄")
("thlj" "劓" "鼻")
("thlv" "鼽")
("thnu" "息")
("thpd" "延")
("thsu" "臬")
("tief" "筲")
("tieg" "稍")
("tifh" "衍")
("tifn" "愆")
("tigf" "簿")
("timk" "徜")
("tirf" "箔")
("titt" "秒")
("tjf" "香")
("tjgf" "笪" "得")
("tjgh" "筛")
("tjh" "利")
("tjrh" "犁")
("tjsu" "梨")
("tjsy" "稞")
("tjtl" "篮")
("tjtt" "馥")
("tjtu" "复")
("tkf" "各")
("tkg" "和")
("tkgg" "程")
("tkhh" "种")
("tkhm" "篑")
("tkkg" "稆")
("tkmy" "禹")
("tkwy" "雒" "积")
("tlb" "务")
("tld" "血")
("tldt" "篾")
("tlf" "备")
("tlff" "睾")
("tlgj" "箅")
("tlkf" "笳")
("tlkg" "徊")
("tlnf" "衄")
("tlnu" "惫")
("tlon" "粤")
("tlpu" "笾")
("tlqi" "囟" "囱")
("tlqu" "箩")
("tluf" "衅")
("tlwt" "稷")
("tmaq" "区")
("tmb" "秃")
("tmcy" "役")
("tmdf" "射")
("tmdk" "躺")
("tmdm" "颓")
("tmdq" "躯")
("tmds" "躲")
("tmdt" "身")
("tmdx" "躬")
("tmdy" "秧")
("tmf" "笛")
("tmfk" "稠")
("tmgk" "筒")
("tmgt" "徵" "徽" "微")
("tmhk" "币")
("tmkd" "向")
("tmod" "奥")
("tmqb" "笕")
("tmqy" "秽")
("tnb" "乞")
("tngk" "笥")
("tnnw" "筷")
("tnpv" "迄")
("tntt" "秘")
("toch" "释")
("tolb" "鄱")
("tolf" "番")
("toln" "翻")
("tomg" "釉")
("tonr" "簖")
("tonu" "悉" "愁")
("tovf" "篓")
("toy" "秋")
("tpey" "稼")
("tpi" "乏")
("tpnn" "管")
("tpqb" "箢")
("tpwa" "箜")
("tqdh" "衡" "稀")
("tqfh" "衔")
("tqiy" "称")
("tqjg" "徇")
("tqkf" "笱")
("tqqy" "移")
("tqrq" "篼")
("tqrr" "笏")
("tqti" "黎")
("tqto" "黧")
("tqvh" "筝")
("tqvn" "稳")
("traf" "箝")
("trah" "箍")
("trcb" "筢")
("trch" "箨")
("trdg" "牯")
("trdk" "犄")
("trfd" "犊")
("trff" "特")
("trfg" "牡")
("trfh" "循")
("trgf" "篁")
("trgg" "徨")
("trgk" "牾")
("trhb" "御")
("trhm" "篪")
("trhw" "犋")
("trhy" "笊")
("trie" "穆")
("trkf" "筘")
("trng" "鹅")
("trnt" "我")
("trql" "籀")
("trqr" "物")
("trsg" "牺")
("trtf" "稗")
("trtg" "牲")
("trtk" "牿")
("trtn" "牦")
("trty" "牧")
("trvp" "犍")
("trwy" "秩")
("trxn" "牝")
("trya" "犏")
("tryk" "犒")
("tryt" "徼")
("tsgf" "笨")
("tshf" "箱")
("tsjj" "簟")
("tssu" "篥")
("tsu" "条")
("tsyy" "秫")
("ttdp" "篷")
("ttdu" "笑")
("ttfn" "笔")
("ttfq" "筅")
("ttgf" "笙")
("ttgh" "竹")
("ttgy" "攵")
("tthf" "笮")
("tthp" "筵")
("ttll" "丿")
("ttlx" "篦")
("ttnt" "秭" "笫")
("ttny" "夂")
("ttth" "彳")
("tttt" "禾")
("tudh" "徉")
("tuej" "箭")
("tuf" "笠")
("tufh" "科")
("tuhk" "乎")
("tujf" "箪" "简")
("tujj" "螽")
("tukq" "税")
("tuu" "冬")
("tuxj" "剩")
("tuxv" "乘")
("tvel" "簋")
("tvey" "很")
("tvf" "委")
("tvfh" "律")
("tvij" "箫")
("tvkf" "笤")
("tvpd" "逶")
("tvrc" "魏")
("tvtr" "笋")
("twar" "筏")
("twfu" "符")
("twgf" "筌")
("twgi" "签")
("twgk" "答")
("twgu" "簦")
("twht" "筱")
("twik" "黏")
("twiu" "黍")
("twkg" "‰")
("twnd" "篌")
("twty" "徐")
("twyg" "稚")
("twyn" "稔")
("txen" "胤")
("txeu" "篆")
("txgg" "鳘")
("txgi" "繁")
("txgq" "毓")
("txgt" "敏")
("txgu" "每")
("txht" "第")
("txiu" "系")
("txty" "後")
("txxf" "筚")
("txxn" "秕")
("tybc" "篱")
("tygg" "往")
("tyi" "入")
("tyiu" "汆")
("tyke" "穰")
("tymk" "稿" "篙")
("tyn" "彷")
("tyna" "篇")
("tynx" "簏")
("tyou" "籴")
("tytd" "簇")
("tyve" "稂")
("uafd" "疳")
("uagd" "疟")
("uagn" "瓶")
("uaiy" "冻")
("uaj" "并")
("uajd" "瘼")
("uakg" "阈" "§")
("uamw" "癀")
("uapk" "迸")
("uapl" "痨")
("uawk" "瘩")
("ubd" "闻")
("ubk" "疗" "疖")
("ubqn" "瘾")
("ubte" "朔")
("ubtf" "塑")
("ubtg" "癃")
("ubtp" "逆")
("ubts" "槊")
("ucad" "痉")
("ucd" "闯")
("ucek" "痛")
("uceu" "衮")
("ucg" "冯")
("uckg" "冶")
("ucqb" "兖")
("ucv" "疤")
("ucwt" "竣")
("ucwy" "瘫")
("ucyj" "瘙")
("udaf" "差")
("udbb" "卷")
("udbh" "郑")
("udca" "羟")
("udci" "闳")
("udct" "羧")
("udd" "闫")
("udeu" "豢")
("udgt" "减")
("udhf" "眷" "着")
("udhn" "瘛")
("udi" "头")
("udj" "羊")
("udjd" "痱")
("udjh" "判")
("udjn" "羯" "阉")
("udlv" "疬")
("udmo" "羰")
("udnb" "羌")
("udnf" "羞")
("udng" "翔")
("udnv" "疠" "疣")
("udpi" "闼" "送")
("udqg" "鲞")
("udqy" "羝")
("udrc" "叛")
("udrj" "拳")
("udsu" "桊")
("udu" "关")
("udub" "鄯")
("uduk" "善")
("udvb" "券")
("udwc" "羚")
("udwd" "凑")
("udy" "状")
("udyf" "誊")
("udyj" "养")
("uegd" "疽")
("uejj" "前")
("uejn" "翦")
("uejo" "煎")
("uejv" "剪")
("uek" "痈")
("uemc" "毅")
("uepc" "阌")
("uepi" "遂")
("ueyi" "瘃")
("ufcl" "阖")
("uff" "兰")
("uffd" "闺")
("uffi" "痔")
("ufg" "壮")
("ufhm" "癫")
("ufhw" "阗")
("ufk" "斗" "半")
("ufnh" "闱")
("ufni" "痣")
("ufte" "闭")
("ufwt" "凌")
("ufye" "装")
("ugd" "闰" "闩")
("ugdu" "美")
("ugeg" "靖")
("ugfq" "＄")
("ughd" "症")
("ugik" "痞")
("ugkd" "痦")
("ugki" "辣" "竦")
("ugkj" "瘌")
("ugkm" "癞")
("ugku" "痘")
("uglf" "盖")
("ugli" "阑")
("ugmw" "病")
("ugnu" "恙")
("ugod" "羹")
("ugog" "痖")
("ugou" "羔")
("ugqj" "冽")
("ugtt" "羲")
("uguf" "瘗")
("uguw" "羡")
("ugvf" "姜")
("ugvv" "凄")
("ugxg" "冱")
("ugxw" "痍")
("ugyg" "癍")
("uhci" "疲")
("uhdi" "阒")
("uhhy" "癯")
("uhk" "丫")
("uhkg" "站")
("uhtt" "夔")
("uhxv" "疵")
("uiit" "痧")
("uitd" "阔")
("uiwe" "瘠")
("uiy" "冰")
("ujbh" "鄣")
("ujd" "间")
("ujet" "彰")
("ujf" "音")
("ujfb" "郸")
("ujfe" "冁")
("ujff" "童")
("ujfj" "单")
("ujgd" "疸")
("uji" "闽")
("ujj" "章")
("ujjd" "阊")
("ujld" "瘟")
("ujnu" "意")
("ujqb" "竟")
("ujqn" "竭")
("ujqu" "韵")
("ujqw" "歆")
("ujtm" "赣")
("ujtn" "戆")
("ujvk" "韶")
("ukbh" "部")
("ukd" "问")
("ukgn" "瓿")
("ukhh" "冲")
("ukjh" "剖")
("ukkd" "闾")
("ukkg" "？")
("ukkm" "癌")
("uknu" "总")
("ukqb" "兑" "竞")
("ukqn" "况")
("uldd" "痼")
("ulgj" "痹")
("ulgk" "兽")
("uljf" "曾")
("uljn" "甑")
("ulk" "闸")
("ulkd" "痂")
("ulkw" "瘸")
("ulsi" "阃")
("ulxi" "瘰")
("umci" "疫")
("umdj" "端")
("umfk" "凋")
("umia" "弊")
("umig" "鳖")
("umih" "蹩" "瞥")
("umin" "憋")
("umit" "敝")
("umk" "疝")
("ummv" "瘿")
("umqi" "疯")
("umqy" "飒")
("umwk" "商")
("unac" "癜")
("unbt" "阚")
("ung" "翊")
("unhc" "瘕")
("uni" "闷")
("unku" "癖")
("unqk" "〈" "〉")
("unre" "疡")
("unwe" "瘳")
("unwy" "决")
("uogj" "普")
("uooi" "痰")
("uovd" "瘘")
("upmh" "帝")
("upmk" "啻")
("upyb" "旁")
("uqaj" "阍")
("uqbh" "郊")
("uqdu" "奖")
("uqfy" "将")
("uqgd" "癣")
("uqiu" "浆")
("uqjn" "阄")
("uqmd" "痪")
("uqnv" "疱")
("uqsg" "酱")
("uqsu" "桨")
("uqty" "效")
("uqu" "交")
("uqvd" "阎")
("uqvh" "净")
("uqwk" "咨")
("uqwl" "盗")
("uqwm" "资")
("uqwn" "瓷" "恣")
("uqwo" "粢")
("uqwv" "姿")
("uqwy" "次")
("uqyi" "疚")
("uqyl" "瘤")
("urcu" "瓣")
("urkg" "′")
("usfi" "瘭")
("usgd" "猷" "奠")
("usgf" "酋" "尊")
("usgp" "遒" "遵")
("usi" "闲")
("usk" "疔")
("uskd" "疴")
("usqg" "鹇")
("usrh" "新")
("usu" "亲")
("uswc" "凇")
("utdi" "疾")
("utdk" "痴")
("ute" "产")
("utec" "瘢")
("utem" "颜")
("uter" "彦")
("utfq" "冼")
("uthf" "首" "痄")
("uthg" "馘")
("uthp" "道")
("uthx" "瘪")
("utjk" "痢")
("utkd" "阁")
("utnv" "疙")
("utui" "疼")
("utvd" "痿")
("uubw" "阙")
("uuda" "瘥")
("uudk" "痒")
("uujf" "瘅" "阐")
("uujk" "瘴")
("uujn" "癔")
("uukq" "阅")
("uusi" "痫")
("uuuu" "立")
("uvei" "痕")
("uvf" "妾")
("uvg" "妆")
("uvhc" "瘦")
("uvog" "鹣")
("uvou" "兼")
("uvow" "歉")
("uvqv" "阋")
("uvwi" "瘐")
("uwae" "阀")
("uwbv" "疮")
("uwee" "疹")
("uwfi" "瘵")
("uwgd" "阕" "痊")
("uwi" "闪")
("uwjk" "疥")
("uwlf" "益")
("uwlj" "蠲")
("uwnd" "瘊")
("uwwf" "痤")
("uwyc" "冷")
("uwyg" "准")
("uxbh" "邶")
("uxef" "背")
("uxhg" "鹈")
("uxhj" "剃")
("uxhp" "递")
("uxht" "弟")
("uxlw" "冀")
("uxn" "北")
("uxth" "凝")
("uxuh" "辫")
("uxxb" "孳")
("uxxg" "鹚")
("uxxn" "慈")
("uxxu" "兹")
("uyg" "冫")
("uygd" "疰")
("uygg" "疒")
("uygh" "辛" "丬")
("uygy" "六")
("uyhn" "门")
("uyi" "闵")
("uyiy" "凉")
("uyli" "凛")
("uymh" "闹")
("uymv" "闶")
("uynw" "阂")
("uytu" "辨")
("uyuh" "辩")
("uyve" "阆")
("uywf" "瘁")
("uywu" "瘀" "阏")
("uyxi" "痃")
("vafs" "媒")
("vahh" "姬")
("vaj" "舁")
("vajd" "嫫")
("vamc" "毁")
("vaqy" "妪")
("vatq" "娆")
("vbg" "好")
("vbhj" "媸")
("vbn" "她")
("vbsk" "婀")
("vcag" "暨")
("vcaq" "既")
("vcbf" "孥")
("vcbh" "即" "妤")
("vccf" "驽")
("vcg" "妈")
("vckg" "始")
("vclb" "努")
("vcmh" "帑")
("vcmw" "胬")
("vcnu" "怒")
("vcxb" "弩")
("vcy" "奴")
("vdfe" "娠")
("vdg" "姑")
("vefc" "媛")
("veff" "垦")
("vegg" "姐")
("vei" "艮")
("ven" "奶")
("venu" "恳")
("vepc" "嫒")
("vepi" "退")
("vfbh" "那")
("vfcy" "妓")
("vffg" "娃")
("vfh" "奸")
("vfhk" "聿")
("vfhp" "建")
("vfiy" "妹")
("vfjf" "媾")
("vfkk" "嬉")
("vfqn" "妩")
("vfsh" "孀")
("vftx" "姥")
("vfu" "寻")
("vfuk" "嫱")
("vgah" "妍")
("vgeg" "婧")
("vgey" "婊")
("vgho" "嫣")
("vgkt" "嫩")
("vgog" "娅")
("vgvh" "婕")
("vgxw" "姨")
("vhcu" "叟")
("vhk" "肀")
("vii" "隶")
("vijh" "剥")
("vijk" "肃")
("viph" "嫦")
("vipi" "逮" "逯")
("viqn" "姚")
("vitt" "妙")
("viu" "录")
("vjd" "旭")
("vjf" "旮")
("vjfg" "娌")
("vjgg" "妲")
("vjjg" "娼")
("vjlg" "媪")
("vjsj" "剿")
("vjsu" "巢")
("vkbh" "邵")
("vkcb" "邕")
("vkeg" "娟")
("vkf" "召")
("vkg" "如")
("vkgd" "娱")
("vkln" "劭")
("vkmw" "娲")
("vknu" "恕")
("vkpd" "迢")
("vkxi" "絮")
("vldy" "姻")
("vlf" "甾")
("vllb" "舅")
("vlqp" "邋")
("vlxi" "嫘")
("vmg" "妯")
("vmgn" "娉")
("vmmg" "姗")
("vnfg" "妞")
("vngg" "彐")
("vnhe" "婿")
("vnhg" "媚")
("vnn" "妃")
("vnnn" "巛")
("vnt" "刀")
("vntn" "娓")
("vnud" "鼷")
("vnuk" "鼯")
("vnum" "鼬")
("vnun" "鼠")
("vnuv" "鼹" "鼢")
("vnxn" "妮")
("vnyw" "姒")
("vou" "灵")
("vpey" "嫁")
("vpjh" "婶")
("vpmh" "帚")
("vpqb" "婉")
("vprw" "嫔")
("vpta" "姹")
("vpv" "巡")
("vqaj" "婚")
("vqkq" "娩")
("vqou" "舄")
("vqyg" "鸠")
("vqyy" "妁")
("vriy" "姝")
("vrtf" "婢")
("vsfi" "嫖")
("vsu" "杂")
("vtdj" "娇")
("vtdy" "妖")
("vte" "尹")
("vtfg" "妊")
("vtgg" "姓")
("vthg" "臼")
("vthn" "媳")
("vtkb" "郡")
("vtkd" "君" "群")
("vtlx" "媲")
("vtn" "九")
("vtnt" "姊")
("vtrt" "娥")
("vuah" "姘")
("vujf" "婵")
("vujh" "嫜")
("vumd" "嫡")
("vuqy" "姣")
("vusy" "娴")
("vutd" "嫉")
("vuth" "馗")
("vuvo" "嫌")
("vuxt" "娣")
("vvfb" "娜")
("vvg" "妇")
("vvhc" "嫂")
("vvvv" "女")
("vwi" "臾")
("vwyn" "妗")
("vxgu" "姆")
("vxxn" "妣")
("vyi" "丸" "刃")
("vylg" "嬗")
("vyly" "妫")
("vyn" "妨")
("vynt" "妒")
("vynu" "忍")
("vyps" "婷")
("vysc" "嬷")
("vyve" "娘")
("wadk" "偌")
("waf" "仝")
("waff" "垡")
("waht" "伢")
("wajg" "借")
("wajv" "偃")
("walo" "黛")
("wamj" "岱")
("wamu" "贷")
("waqj" "僭")
("waqt" "儆")
("waqy" "伛")
("warh" "牮")
("wat" "伐")
("watq" "侥")
("wawy" "供")
("way" "代")
("waye" "袋")
("wbat" "戗")
("wbb" "仓")
("wbg" "佴" "仔")
("wbjh" "创")
("wbn" "他")
("wcdm" "颂")
("wceh" "俑")
("wcgn" "瓮")
("wcnf" "翁")
("wcrh" "侔")
("wctd" "俟")
("wcu" "公")
("wcwt" "俊")
("wcwy" "傩")
("wcy" "仅")
("wdag" "佐")
("wdeg" "侑")
("wdfn" "侉")
("wdg" "估" "仨")
("wdjd" "俳")
("wdjg" "佰")
("wdjn" "俺")
("wdkg" "佑")
("wdmc" "段")
("wdnn" "优")
("wdsk" "倚")
("wdtf" "俦")
("wdty" "做")
("wdui" "僚")
("wdwh" "俸")
("wdwi" "傣")
("wdy" "伏")
("wdyy" "仗")
("webg" "俘")
("weh" "佣")
("wen" "仍")
("wfam" "偾")
("wfcb" "郐")
("wfcj" "刽")
("wfcu" "会")
("wfcy" "伎")
("wfdj" "儒")
("wffg" "佳")
("wffy" "侍")
("wfg" "仁" "仕")
("wfh" "什")
("wfhg" "值")
("wfil" "畲")
("wfiu" "祭" "佘")
("wfiy" "俅")
("wfkb" "舒")
("wfkf" "舍")
("wfkg" "佶")
("wfkk" "僖")
("wflw" "舆")
("wfmo" "爨")
("wfmy" "璺")
("wfnh" "伟")
("wfny" "传")
("wftx" "佬")
("wfvg" "佞")
("wfy" "付")
("wgcf" "侄")
("wgcj" "倒")
("wgdu" "癸")
("wgef" "傅")
("wgeg" "倩")
("wgej" "俞")
("wgen" "毹" "愈")
("wgep" "逾")
("wgeq" "觎")
("wgf" "全")
("wgg" "伍")
("wgif" "佥")
("wgij" "剑")
("wgit" "敛")
("wgjq" "便")
("wgka" "龠")
("wgkb" "命")
("wgkf" "合")
("wgkg" "鸽")
("wgkl" "盒")
("wgkm" "颌" "凳")
("wgkn" "翕")
("wgkq" "使")
("wgkr" "拿")
("wgku" "登")
("wgkw" "歙")
("wgkx" "龛")
("wglg" "僵")
("wgmw" "俩")
("wgmy" "债" "俪")
("wgnb" "兮")
("wgnn" "佤")
("wgod" "俨")
("wgqj" "例")
("wgqt" "傲")
("wguw" "侠")
("whf" "企")
("whhy" "佧")
("whj" "个")
("whjh" "倬")
("whmy" "侦")
("whnd" "候")
("whtd" "倏")
("whte" "修")
("whtn" "悠")
("whty" "攸")
("whwy" "俱")
("why" "仆")
("wieg" "俏")
("wimk" "倘")
("wipc" "偿")
("wipq" "傥")
("wiqn" "佻")
("wiu" "氽")
("wjfg" "俚")
("wjgg" "但")
("wjhh" "伸")
("wjj" "介")
("wjjg" "倡")
("wjmy" "偶")
("wjqn" "偈")
("wjsy" "倮")
("wkgd" "俣")
("wkhh" "仲")
("wkhy" "促")
("wkkg" "侣")
("wkqn" "侃")
("wksf" "堡")
("wkso" "煲")
("wksy" "保")
("wlg" "佃")
("wlge" "儇" "偎")
("wlkg" "伽")
("wlll" "儡")
("wln" "仂")
("wmfk" "倜")
("wmgh" "佩")
("wmgk" "侗")
("wmgn" "俜")
("wmh" "仙")
("wmjh" "侧")
("wmn" "仉")
("wmwy" "催")
("wnbm" "倔")
("wndg" "倨")
("wngk" "伺")
("wnhc" "假")
("wnku" "僻")
("wnn" "亿")
("wnnf" "阜")
("wnnp" "追")
("wntd" "侯")
("wntm" "￥")
("wnxn" "伲")
("wnyw" "似")
("wovg" "偻")
("woy" "伙")
("wpey" "侬")
("wpgg" "伫")
("wpnn" "倌")
("wprw" "傧")
("wpwa" "倥")
("wpxn" "佗")
("wqay" "低")
("wqbh" "仰")
("wqbj" "爷")
("wqcb" "爸")
("wqdy" "儋")
("wqfu" "釜")
("wqin" "您")
("wqiy" "你")
("wqje" "像")
("wqkg" "佝")
("wqqq" "爹")
("wqqy" "侈")
("wqrj" "斧")
("wqrn" "偬")
("wqu" "父")
("wrg" "伯")
("wrhh" "件")
("wriy" "侏")
("wrqc" "傀")
("wrtf" "俾")
("wrwy" "佚")
("wsgg" "体")
("wsh" "仃")
("wskg" "何")
("wsoy" "僳")
("wsqg" "鸺")
("wssy" "傈")
("wsy" "休")
("wtay" "伥")
("wtcy" "仫" "叙")
("wtdj" "侨")
("wtfg" "任")
("wtfh" "仵" "仟")
("wtfm" "赁" "凭")
("wtfn" "恁")
("wth" "亻")
("wthf" "作")
("wtjh" "俐")
("wtln" "伤")
("wtlt" "傻")
("wtnn" "仡")
("wtpi" "途")
("wtrt" "俄")
("wtsa" "／")
("wttk" "¤" "￠")
("wtu" "余")
("wtuf" "斜")
("wtuy" "佟")
("wtvg" "倭")
("wtxu" "侮")
("wty" "八")
("wudb" "倦")
("wudh" "佯")
("wufh" "伴")
("wug" "位")
("wuhj" "伞")
("wujf" "僮")
("wukg" "倍")
("wulj" "僧")
("wun" "们")
("wupy" "傍")
("wuqy" "佼")
("wvb" "分")
("wvdm" "颁")
("wvff" "坌")
("wvfp" "健")
("wvkg" "；")
("wvlf" "盆")
("wvmj" "岔")
("wvmu" "贫")
("wvn" "仇")
("wvnu" "忿")
("wvpc" "侵")
("wvqn" "倪")
("wvtt" "伊")
("wvyy" "仞")
("wwbf" "耸")
("wwbn" "伧")
("wweg" "佾" "俎")
("wwfc" "侩")
("wwff" "坐")
("wwfi" "傺")
("wwgf" "丛")
("wwgi" "俭")
("wwgj" "偷")
("wwjh" "价")
("wwkf" "谷")
("wwkg" "鹆")
("wwkw" "欲")
("wwnu" "怂")
("wwvn" "份")
("wwwk" "俗")
("wwwu" "众")
("wwww" "人")
("wwxn" "伦")
("wwy" "从")
("wwyc" "伶")
("wwyo" "僬")
("wxb" "仑")
("wxdm" "倾")
("wxfj" "华")
("wxjh" "佛")
("wxmu" "货")
("wxn" "化")
("wxxn" "仳")
("wxxr" "偕")
("wybc" "禽")
("wycb" "邻")
("wycm" "领")
("wycn" "翎" "瓴")
("wyeb" "隽")
("wyey" "依")
("wyfj" "隼" "储")
("wyg" "隹" "信")
("wygg" "住")
("wyin" "僦")
("wyjh" "侪")
("wykf" "售")
("wyly" "伪")
("wymn" "伉")
("wyn" "仿")
("wyna" "偏")
("wynb" "今")
("wyne" "衾")
("wynk" "含")
("wynm" "贪" "颔")
("wynn" "念")
("wyog" "鹪")
("wyoj" "劁")
("wyou" "焦")
("wyps" "停")
("wyqy" "仪")
("wysu" "集")
("wyve" "食")
("wywf" "俯")
("wyyv" "令")
("wyyy" "雠")
("xadt" "绒")
("xafg" "绀")
("xafh" "缂")
("xag" "红")
("xann" "绁")
("xanw" "练")
("xatq" "绕")
("xbg" "弭")
("xbmh" "绌")
("xbn" "弛")
("xcag" "弪" "经")
("xcbh" "纾")
("xccc" "缀")
("xcfh" "绎")
("xckg" "绐")
("xcy" "弘")
("xdcy" "绂")
("xde" "毋")
("xdff" "缛")
("xdfn" "绔")
("xdgt" "缄")
("xdjd" "绯")
("xdjx" "弼")
("xdmd" "缅")
("xdmy" "顷")
("xdsk" "绮")
("xdtb" "绑")
("xdui" "缭")
("xeeg" "绷")
("xefc" "缓")
("xegg" "组")
("xejj" "蠡")
("xepc" "绶")
("xeu" "彖")
("xevg" "绥")
("xeyy" "级")
("xfcy" "纭")
("xfgg" "疆")
("xfhw" "缜")
("xfkg" "结")
("xfkm" "缬")
("xfmu" "贯")
("xfnd" "续")
("xfnh" "纬")
("xfqg" "鸨")
("xftj" "绪")
("xfwt" "绫")
("xfy" "纣")
("xgbn" "纯")
("xgef" "缚")
("xgfh" "纡")
("xgjq" "绠")
("xglg" "缰")
("xgmy" "绩")
("xgoa" "彝")
("xgoj" "缙")
("xgt" "线")
("xgui" "母")
("xgxx" "彘")
("xhh" "引")
("xhit" "缈")
("xhjh" "绰")
("xidm" "颍")
("xieg" "绡")
("ximk" "绱")
("xitt" "纱")
("xiu" "糸")
("xjf" "旨")
("xjgh" "缇")
("xjhh" "绅")
("xjk" "弗")
("xjlc" "缦")
("xjmu" "费")
("xjqc" "艴")
("xjtq" "缆")
("xjxx" "绲")
("xkbg" "缉")
("xkeg" "绢")
("xkhm" "缋")
("xkhp" "缱")
("xkjh" "犟")
("xkjn" "绳")
("xkjy" "强")
("xkks" "缲")
("xkwy" "织")
("xlg" "细")
("xlge" "缳")
("xln" "幼")
("xlny" "缌")
("xlxi" "缧")
("xlxk" "辔")
("xmfk" "绸")
("xmmv" "缨")
("xmqy" "纲")
("xmwy" "纳")
("xnaj" "缗")
("xnfg" "纽")
("xngn" "弓")
("xnhh" "纠")
("xnn" "纪" "幻")
("xnng" "纟")
("xnny" "幺")
("xnwe" "缪")
("xonn" "继")
("xovg" "缕")
("xoxh" "鬻")
("xoxn" "粥")
("xpfi" "综")
("xpgh" "绽")
("xpnn" "绾")
("xprw" "缤")
("xpwj" "缩")
("xqan" "纸")
("xqcn" "绝")
("xqiy" "弥")
("xqjg" "绚")
("xqvg" "绉")
("xqyy" "约")
("xrcy" "弧")
("xrmh" "绵")
("xryt" "缴")
("xsfi" "缥")
("xshg" "缃")
("xtah" "绛")
("xtay" "张")
("xtdh" "肄" "疑")
("xtdm" "颖")
("xtdp" "缝")
("xte" "乡")
("xten" "绣")
("xtfh" "纤" "绗")
("xtfm" "缵")
("xtgf" "缍" "≈")
("xthk" "绺")
("xtkg" "络")
("xtn" "匕")
("xtnn" "纥")
("xtsy" "绦")
("xtuy" "终")
("xtwe" "飨")
("xudb" "绻")
("xudk" "缮")
("xufh" "绊")
("xujf" "弹")
("xulj" "缯")
("xuph" "缔")
("xuqy" "绞")
("xuvo" "缣")
("xuwl" "缢")
("xuxt" "绨")
("xuxu" "弱")
("xviy" "绿")
("xvjs" "缫")
("xvkg" "绍")
("xvlg" "缁")
("xvyy" "纨" "纫")
("xwdc" "缎")
("xwfc" "绘")
("xwgk" "给")
("xwgq" "缏")
("xwnd" "缑")
("xwnp" "缒")
("xwvn" "纷")
("xwwy" "纵")
("xwxn" "纶")
("xwyg" "维")
("xxal" "畿")
("xxey" "缘")
("xxfj" "毕")
("xxgf" "丝")
("xxgg" "鸶")
("xxgx" "毙")
("xxjh" "绋")
("xxmk" "幽")
("xxn" "比")
("xxnt" "毖")
("xxrf" "皆")
("xxxn" "纰")
("xybc" "缡")
("xycq" "统")
("xyjf" "缠")
("xymk" "缟")
("xyn" "纺")
("xyna" "编")
("xyt" "纩")
("xyxy" "弦")
("xyy" "纹")
("ya" "°")
("yaag" "试")
("yaah" "诫")
("yaci" "度")
("yadk" "诺")
("yadn" "谌")
("yafs" "谋")
("yag" "讧")
("yagg" "诓")
("yaht" "讶")
("yajd" "谟")
("yakg" "廑" "谨")
("yamh" "席")
("yang" "讵")
("yans" "谍")
("yany" "庹")
("yaog" "鹧")
("yaoi" "庶")
("yaop" "遮")
("yaqj" "谮")
("yaqy" "讴")
("yaww" "诬")
("yayq" "谎")
("ybbh" "郭")
("ybcy" "诹")
("ybf" "享")
("ybh" "邡" "邝")
("ybj" "亨")
("ybmc" "离")
("ybmh" "诎")
("ybou" "烹")
("ybqg" "鹑")
("ybtn" "憝")
("ybty" "敦")
("ybvf" "塾")
("ybvo" "熟")
("ybvy" "孰")
("ycaj" "弃")
("ycbe" "袤")
("ycbk" "序" "谲")
("ycef" "育")
("yceh" "诵")
("ycfh" "译")
("yckg" "诒" "№")
("ycqb" "充")
("yctd" "诶")
("ydg" "诂")
("ydi" "庆")
("ydiy" "诔")
("ydjd" "诽")
("ydjj" "齑")
("ydjn" "庵")
("ydmj" "斋")
("ydnt" "诚")
("ydoy" "诙")
("ydxv" "庞")
("yefc" "谖")
("yegg" "诅")
("yemk" "裔")
("yerm" "谣")
("yeu" "衣" "哀")
("yeyy" "诼")
("yfci" "庋")
("yfd" "庄")
("yffg" "诖")
("yffy" "诗")
("yfh" "讦" "计")
("yfjh" "讲")
("yfkg" "诘")
("yfmd" "谳")
("yfnd" "读")
("yfnh" "讳")
("yfqv" "庑")
("yftj" "诸")
("yfy" "讨")
("ygah" "斌")
("ygd" "主")
("ygeg" "请")
("yghg" "证")
("ygkg" "语")
("ygli" "谏")
("ygqt" "廒")
("yguh" "评")
("yhag" "谑")
("yhg" "让")
("yhkd" "店")
("yhu" "卞")
("yhy" "讣")
("yid" "应")
("yidg" "鹫")
("yidn" "就")
("yieg" "诮")
("yipq" "谠")
("yiu" "京")
("yjff" "廛")
("yjh" "刘")
("yjj" "齐")
("yjjh" "剂")
("yjlc" "谩")
("yjqn" "谒")
("yjse" "裹")
("yjsy" "课")
("ykf" "吝")
("ykgd" "误")
("ykge" "衰")
("ykh" "训")
("ykhe" "衷")
("ykhp" "谴")
("ykke" "襄")
("ykkn" "谔")
("ykky" "瓤")
("ykwy" "识")
("yleg" "谓")
("ylf" "亩")
("ylk" "库")
("ylki" "禀")
("ylkm" "颤")
("ylwt" "谡")
("ylyi" "为")
("ymb" "亢")
("ymcy" "设")
("ymd" "庙")
("ymdm" "颃")
("ymfk" "调")
("ymh" "讪")
("ymhj" "市")
("ymkc" "敲")
("ymkf" "高")
("ymn" "讥")
("ymqy" "讽")
("ymwy" "讷")
("ynbh" "邙")
("yndd" "扉")
("yndi" "戾")
("yne" "户")
("yned" "肩")
("ynef" "肓")
("yneg" "望")
("ynfh" "讯")
("yng" "诩")
("yngk" "词")
("ynhf" "盲")
("ynii" "永")
("ynij" "昶")
("ynjf" "麝")
("ynjg" "麈")
("ynjh" "麟")
("ynjm" "麂")
("ynjo" "麋")
("ynjq" "鏖")
("ynjt" "麇")
("ynjw" "麒")
("ynjx" "鹿")
("ynkc" "扈")
("ynkd" "启")
("ynky" "赢" "羸" "蠃" "嬴")
("ynma" "扁")
("ynmk" "扃")
("ynmn" "翩")
("ynmp" "遍")
("ynn" "记")
("ynna" "氓")
("ynnd" "扇")
("ynnu" "忘")
("ynth" "肇")
("ynti" "綮")
("yntj" "刻")
("yntl" "谧" "劾")
("yntm" "颏")
("yntw" "亥")
("ynty" "废")
("ynuf" "戽")
("ynv" "亡")
("ynvf" "妄")
("ynwe" "谬" "廖")
("ynwy" "雇" "诀")
("ynyv" "房")
("yoaj" "弈")
("yobf" "孪")
("yocu" "变")
("yodu" "奕")
("yoju" "蛮")
("yomj" "峦")
("yomw" "脔")
("yonu" "恋")
("yooy" "谈")
("yopi" "迹")
("yopy" "谜")
("yoqf" "銮")
("yoqg" "鸾")
("yorj" "挛")
("yosu" "栾")
("you" "亦")
("yovf" "娈")
("yoxb" "弯")
("ypeg" "谊")
("ypeu" "豪")
("ypi" "这")
("ypke" "膏")
("yplh" "诨")
("ypmb" "亮")
("ypsj" "亭")
("ypta" "亳" "诧")
("yptn" "毫")
("yqay" "底" "诋")
("yqdb" "诡")
("yqdy" "谵")
("yqeh" "廨")
("yqi" "义")
("yqjg" "询")
("yqku" "谗")
("yqnv" "庖")
("yqtg" "诳")
("yqvg" "诌" "谄")
("yqvh" "诤")
("yrgk" "诟")
("yriy" "诛")
("yrkg" "〕" "〔")
("yrtf" "庳")
("yrve" "亵")
("yryy" "诉")
("ysh" "订")
("ysi" "床")
("ysjh" "谭")
("yskg" "诃")
("yssc" "魔" "麽")
("yssd" "磨" "靡")
("yssi" "麻" "縻")
("yssn" "麾")
("ysso" "糜")
("yssr" "摩")
("ytaw" "旗")
("ytbn" "施")
("ytdg" "话")
("ytdk" "旖")
("ytee" "膂")
("yten" "诱")
("ytey" "旅")
("ytfh" "许")
("ytfk" "诰")
("ytfp" "庭")
("ytfq" "诜")
("ytgh" "旆")
("ythf" "诈")
("ythp" "诞")
("ytmf" "谢")
("ytmy" "旃")
("ytnh" "旋")
("ytnn" "讫")
("ytnx" "旎")
("yttd" "族")
("yttg" "旌")
("yttn" "旄")
("yttu" "→" "↓" "←" "↑")
("ytvg" "诿")
("ytxu" "诲")
("yty" "放")
("ytyh" "州")
("ytyq" "旒")
("yudh" "详")
("yudk" "庠")
("yuev" "谫")
("yugi" "斓" "谰")
("yujg" "谙")
("yukq" "说")
("yumd" "谪")
("yuoj" "谱")
("yuph" "谛")
("yupy" "谤")
("yuqk" "谘")
("yute" "谚")
("yuvo" "谦" "廉")
("yuwl" "谥")
("yvcb" "郎")
("yvce" "朗")
("yveh" "庸")
("yvei" "良")
("yveu" "裒")
("yvhk" "唐")
("yvii" "康")
("yvkg" "诏")
("yvwi" "庚" "庾")
("yvwm" "赓")
("yvwy" "谀")
("ywcy" "讼")
("ywet" "诊")
("ywfi" "府")
("ywfw" "腐")
("ywgg" "诠")
("ywgj" "谕")
("ywke" "褒")
("ywsi" "庥")
("ywty" "夜")
("ywuy" "於")
("ywwe" "膺")
("ywwf" "座" "卒")
("ywwg" "谶" "鹰")
("ywxn" "讹" "论")
("ywy" "认")
("ywyg" "谁")
("ywyn" "谂")
("ywyo" "谯")
("yxif" "率")
("yxiu" "紊")
("yxjg" "诣")
("yxlf" "畜")
("yxte" "饔")
("yxtf" "壅")
("yxty" "雍")
("yxu" "玄")
("yxv" "庀")
("yxxr" "谐")
("yxxv" "庇")
("yybb" "廓")
("yybg" "谆")
("yyg" "亠")
("yygn" "方")
("yygt" "广")
("yygy" "文")
("yyiy" "谅")
("yyli" "廪")
("yyll" "丶")
("yyn" "访" "讠")
("yyna" "谝")
("yyne" "庐")
("yynw" "该")
("yyqy" "议")
("yyvb" "廊")
("yywf" "谇")
("yyyy" "言")
) chinese-wbim-wb-char-table)
